--  C:\PROJETO_ISH\MULTILATERATION\EXPS_CALC_CONTROL.vhd
--  VHDL code created by Xilinx's StateCAD 9.1i
--  Thu Jun 28 22:25:48 2007

--  This VHDL code (for use with Xilinx XST) was generated using: 
--  binary encoded state assignment with structured code format.
--  Minimization is enabled,  implied else is enabled, 
--  and outputs are manually optimized.

LIBRARY ieee;
USE ieee.std_logic_1164.all;

LIBRARY ieee;
USE ieee.std_logic_unsigned.all;

ENTITY SHELL_EXPS_CALC_CONTROL IS
	PORT (CLK,add1_rdy,mult1_rdy,SCLR,START: IN std_logic;
		add1_nd,add_a_mux_sel0,add_a_mux_sel1,add_b_mux_sel,exp1_load,
			exp1m_reg_load,exp2_load,exp2m_reg_load,exp3_load,exp3m_reg_load,mult1_nd,RDY
			,router_sel0,router_sel1,router_sel2,router_sel3 : OUT std_logic);
END;

ARCHITECTURE BEHAVIOR OF SHELL_EXPS_CALC_CONTROL IS
	SIGNAL sreg : std_logic_vector (4 DOWNTO 0);
	SIGNAL next_sreg : std_logic_vector (4 DOWNTO 0);
	CONSTANT ADD1_0_WAIT_ST : std_logic_vector (4 DOWNTO 0) :="00000";
	CONSTANT ADD1_12_WAIT_ST : std_logic_vector (4 DOWNTO 0) :="00001";
	CONSTANT ADD1_INIT_ST : std_logic_vector (4 DOWNTO 0) :="00010";
	CONSTANT ADD2_INIT_ST : std_logic_vector (4 DOWNTO 0) :="00011";
	CONSTANT EXP1_STORE_ST : std_logic_vector (4 DOWNTO 0) :="00100";
	CONSTANT EXP1_WAIT_ST : std_logic_vector (4 DOWNTO 0) :="00101";
	CONSTANT EXP2_STORE_ST : std_logic_vector (4 DOWNTO 0) :="00110";
	CONSTANT EXP2_WAIT_ST : std_logic_vector (4 DOWNTO 0) :="00111";
	CONSTANT EXP3_ST_RDY_ST : std_logic_vector (4 DOWNTO 0) :="01000";
	CONSTANT EXP3_WAIT_ST : std_logic_vector (4 DOWNTO 0) :="01001";
	CONSTANT EXPS_RDY_ST : std_logic_vector (4 DOWNTO 0) :="01010";
	CONSTANT IDLE_ST : std_logic_vector (4 DOWNTO 0) :="01011";
	CONSTANT MULT1_WAIT_ST : std_logic_vector (4 DOWNTO 0) :="01100";
	CONSTANT MULT3_EXP1_ST : std_logic_vector (4 DOWNTO 0) :="01101";
	CONSTANT MULT3_EXP2_ST : std_logic_vector (4 DOWNTO 0) :="01110";
	CONSTANT MULT3_EXP3_ST : std_logic_vector (4 DOWNTO 0) :="01111";
	CONSTANT MULT_STORE_ST : std_logic_vector (4 DOWNTO 0) :="10000";
	CONSTANT MULTS_INIT_ST : std_logic_vector (4 DOWNTO 0) :="10001";

	SIGNAL next_add_a_mux_sel0,next_add_a_mux_sel1,next_add_count0,
		next_add_count1,next_mult_count0,next_mult_count1,next_mult_count2,
		next_mult_count3 : std_logic;
	SIGNAL add_a_mux_sel : std_logic_vector (1 DOWNTO 0);
	SIGNAL add_count : std_logic_vector (1 DOWNTO 0);
	SIGNAL mult_count : std_logic_vector (3 DOWNTO 0);
	SIGNAL router_sel : std_logic_vector (3 DOWNTO 0);

	SIGNAL add_count0,add_count1,mult_count0,mult_count1,mult_count2,mult_count3
		: std_logic;
BEGIN
	PROCESS (CLK, next_sreg, next_add_a_mux_sel1, next_add_a_mux_sel0, 
		next_add_count1, next_add_count0, next_mult_count3, next_mult_count2, 
		next_mult_count1, next_mult_count0)
	BEGIN
		IF CLK='1' AND CLK'event THEN
			sreg <= next_sreg;
			add_a_mux_sel1 <= next_add_a_mux_sel1;
			add_a_mux_sel0 <= next_add_a_mux_sel0;
			add_count1 <= next_add_count1;
			add_count0 <= next_add_count0;
			mult_count3 <= next_mult_count3;
			mult_count2 <= next_mult_count2;
			mult_count1 <= next_mult_count1;
			mult_count0 <= next_mult_count0;
		END IF;
	END PROCESS;

	PROCESS (sreg,add1_rdy,add_count0,add_count1,mult1_rdy,mult_count0,
		mult_count1,mult_count2,mult_count3,SCLR,START,add_a_mux_sel,add_count,
		mult_count)
	BEGIN
		add1_nd <= '0'; next_add_a_mux_sel0 <= '0'; next_add_a_mux_sel1 <= '0'; 
			add_b_mux_sel <= '0'; next_add_count0 <= '0'; next_add_count1 <= '0'; 
			exp1_load <= '0'; exp1m_reg_load <= '0'; exp2_load <= '0'; exp2m_reg_load <= 
			'0'; exp3_load <= '0'; exp3m_reg_load <= '0'; mult1_nd <= '0'; 
			next_mult_count0 <= '0'; next_mult_count1 <= '0'; next_mult_count2 <= '0'; 
			next_mult_count3 <= '0'; RDY <= '0'; 
		add_a_mux_sel<=std_logic_vector'("00"); add_count<=std_logic_vector'("00");
			 mult_count<=std_logic_vector'("0000"); 

		next_sreg<=ADD1_0_WAIT_ST;

		IF ( SCLR='1' ) THEN
			next_sreg<=IDLE_ST;
			RDY<='0';
			mult1_nd<='0';
			exp3m_reg_load<='0';
			exp3_load<='0';
			exp2m_reg_load<='0';
			exp2_load<='0';
			exp1m_reg_load<='0';
			exp1_load<='0';
			add_b_mux_sel<='0';
			add1_nd<='0';

			add_a_mux_sel <= (std_logic_vector'("00"));
			add_count <= (std_logic_vector'("00"));
			mult_count <= (std_logic_vector'("1110"));
		ELSE
			CASE sreg IS
				WHEN ADD1_0_WAIT_ST =>
					RDY<='0';
					mult1_nd<='0';
					exp3m_reg_load<='0';
					exp3_load<='0';
					exp2m_reg_load<='0';
					exp2_load<='0';
					exp1m_reg_load<='0';
					exp1_load<='0';
					add_b_mux_sel<='0';
					add1_nd<='0';
					IF ( add1_rdy='1' ) THEN
						next_sreg<=ADD2_INIT_ST;

						mult_count <= (std_logic_vector'("0000"));
						add_a_mux_sel <= (( std_logic_vector'(add_count1, add_count0)));
						add_count <= (( std_logic_vector'(add_count1, add_count0)));
					 ELSE
						next_sreg<=ADD1_0_WAIT_ST;

						mult_count <= (std_logic_vector'("0000"));
						add_count <= (std_logic_vector'("00"));
						add_a_mux_sel <= (std_logic_vector'("00"));
					END IF;
				WHEN ADD1_12_WAIT_ST =>
					RDY<='0';
					mult1_nd<='0';
					exp3m_reg_load<='0';
					exp3_load<='0';
					exp2m_reg_load<='0';
					exp2_load<='0';
					exp1m_reg_load<='0';
					exp1_load<='0';
					add_b_mux_sel<='0';
					add1_nd<='0';
					IF ( add_count0='1' AND add_count1='1' ) THEN
						next_sreg<=EXP1_WAIT_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0000"));
					 ELSE
						next_sreg<=ADD2_INIT_ST;

						mult_count <= (std_logic_vector'("0000"));
						add_a_mux_sel <= (( std_logic_vector'(add_count1, add_count0)));
						add_count <= (( std_logic_vector'(add_count1, add_count0)));
					END IF;
				WHEN ADD1_INIT_ST =>
					RDY<='0';
					mult1_nd<='0';
					exp3m_reg_load<='0';
					exp3_load<='0';
					exp2m_reg_load<='0';
					exp2_load<='0';
					exp1_load<='0';
					exp1m_reg_load<='0';
					add_b_mux_sel<='0';
					add1_nd<='1';
					IF ( add_count0='1' AND add_count1='1' ) THEN
						next_sreg<=MULT3_EXP1_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0000"));
					 ELSE
						next_sreg<=MULT_STORE_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0000"));
						add_count <= (( std_logic_vector'(add_count1, add_count0)));
					END IF;
				WHEN ADD2_INIT_ST =>
					RDY<='0';
					mult1_nd<='0';
					exp3m_reg_load<='0';
					exp3_load<='0';
					exp2m_reg_load<='0';
					exp2_load<='0';
					exp1m_reg_load<='0';
					exp1_load<='0';
					add_b_mux_sel<='1';
					add1_nd<='1';
					next_sreg<=ADD1_12_WAIT_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
					add_count <= (( std_logic_vector'(add_count1, add_count0)) +
						std_logic_vector'("01"));
				WHEN EXP1_STORE_ST =>
					RDY<='0';
					mult1_nd<='0';
					exp3m_reg_load<='0';
					exp3_load<='0';
					exp2m_reg_load<='0';
					exp2_load<='0';
					exp1m_reg_load<='0';
					add_b_mux_sel<='0';
					add1_nd<='0';
					exp1_load<='0';
					next_sreg<=EXP2_WAIT_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
				WHEN EXP1_WAIT_ST =>
					RDY<='0';
					mult1_nd<='0';
					exp3m_reg_load<='0';
					exp3_load<='0';
					exp2m_reg_load<='0';
					exp2_load<='0';
					exp1m_reg_load<='0';
					add_b_mux_sel<='0';
					add1_nd<='0';
					exp1_load<='1';
					IF ( add1_rdy='1' ) THEN
						next_sreg<=EXP1_STORE_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0000"));
					 ELSE
						next_sreg<=EXP1_WAIT_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0000"));
					END IF;
				WHEN EXP2_STORE_ST =>
					RDY<='0';
					mult1_nd<='0';
					exp3m_reg_load<='0';
					exp3_load<='0';
					exp2m_reg_load<='0';
					exp1m_reg_load<='0';
					exp1_load<='0';
					add_b_mux_sel<='0';
					add1_nd<='0';
					exp2_load<='0';
					next_sreg<=EXP3_WAIT_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
				WHEN EXP2_WAIT_ST =>
					RDY<='0';
					mult1_nd<='0';
					exp3m_reg_load<='0';
					exp3_load<='0';
					exp2m_reg_load<='0';
					exp1m_reg_load<='0';
					exp1_load<='0';
					add_b_mux_sel<='0';
					add1_nd<='0';
					exp2_load<='1';
					next_sreg<=EXP2_STORE_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
				WHEN EXP3_ST_RDY_ST =>
					mult1_nd<='0';
					exp3m_reg_load<='0';
					exp2m_reg_load<='0';
					exp2_load<='0';
					exp1m_reg_load<='0';
					exp1_load<='0';
					add_b_mux_sel<='0';
					add1_nd<='0';
					RDY<='1';
					exp3_load<='0';
					next_sreg<=EXPS_RDY_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
				WHEN EXP3_WAIT_ST =>
					RDY<='0';
					mult1_nd<='0';
					exp3m_reg_load<='0';
					exp2m_reg_load<='0';
					exp2_load<='0';
					exp1m_reg_load<='0';
					exp1_load<='0';
					add_b_mux_sel<='0';
					add1_nd<='0';
					exp3_load<='1';
					next_sreg<=EXP3_ST_RDY_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
				WHEN EXPS_RDY_ST =>
					mult1_nd<='0';
					exp3m_reg_load<='0';
					exp3_load<='0';
					exp2m_reg_load<='0';
					exp2_load<='0';
					exp1m_reg_load<='0';
					exp1_load<='0';
					add_b_mux_sel<='0';
					add1_nd<='0';
					RDY<='1';
					IF ( START='1' ) THEN
						next_sreg<=MULTS_INIT_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("00"));
						mult_count <= (( std_logic_vector'(mult_count3, mult_count2, 
							mult_count1, mult_count0)) +std_logic_vector'("0001"));
					 ELSE
						next_sreg<=EXPS_RDY_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0000"));
					END IF;
				WHEN IDLE_ST =>
					RDY<='0';
					mult1_nd<='0';
					exp3m_reg_load<='0';
					exp3_load<='0';
					exp2m_reg_load<='0';
					exp2_load<='0';
					exp1m_reg_load<='0';
					exp1_load<='0';
					add_b_mux_sel<='0';
					add1_nd<='0';
					IF ( START='1' ) THEN
						next_sreg<=MULTS_INIT_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("00"));
						mult_count <= (( std_logic_vector'(mult_count3, mult_count2, 
							mult_count1, mult_count0)) +std_logic_vector'("0001"));
					 ELSE
						next_sreg<=IDLE_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("1110"));
					END IF;
				WHEN MULT1_WAIT_ST =>
					RDY<='0';
					exp3m_reg_load<='0';
					exp3_load<='0';
					exp2m_reg_load<='0';
					exp2_load<='0';
					exp1m_reg_load<='0';
					exp1_load<='0';
					add_b_mux_sel<='0';
					add1_nd<='0';
					mult1_nd<='0';
					IF ( mult1_rdy='1' ) THEN
						next_sreg<=MULT_STORE_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0000"));
						add_count <= (( std_logic_vector'(add_count1, add_count0)));
					 ELSE
						next_sreg<=MULT1_WAIT_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0000"));
						add_count <= (std_logic_vector'("00"));
					END IF;
				WHEN MULT3_EXP1_ST =>
					RDY<='0';
					mult1_nd<='0';
					exp3m_reg_load<='0';
					exp3_load<='0';
					exp2m_reg_load<='0';
					exp2_load<='0';
					exp1_load<='0';
					add_b_mux_sel<='0';
					add1_nd<='0';
					exp1m_reg_load<='1';
					next_sreg<=MULT3_EXP2_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
				WHEN MULT3_EXP2_ST =>
					RDY<='0';
					mult1_nd<='0';
					exp3m_reg_load<='0';
					exp3_load<='0';
					exp2_load<='0';
					exp1_load<='0';
					add_b_mux_sel<='0';
					add1_nd<='0';
					exp1m_reg_load<='0';
					exp2m_reg_load<='1';
					next_sreg<=MULT3_EXP3_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
				WHEN MULT3_EXP3_ST =>
					RDY<='0';
					mult1_nd<='0';
					exp3_load<='0';
					exp2_load<='0';
					exp1m_reg_load<='0';
					exp1_load<='0';
					add_b_mux_sel<='0';
					add1_nd<='0';
					exp2m_reg_load<='0';
					exp3m_reg_load<='1';
					next_sreg<=ADD1_0_WAIT_ST;

					mult_count <= (std_logic_vector'("0000"));
					add_count <= (std_logic_vector'("00"));
					add_a_mux_sel <= (std_logic_vector'("00"));
				WHEN MULT_STORE_ST =>
					RDY<='0';
					mult1_nd<='0';
					exp3m_reg_load<='0';
					exp3_load<='0';
					exp2m_reg_load<='0';
					exp2_load<='0';
					exp1_load<='0';
					add_b_mux_sel<='0';
					exp1m_reg_load<='1';
					add1_nd<='1';
					next_sreg<=ADD1_INIT_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
					add_count <= (( std_logic_vector'(add_count1, add_count0)) +
						std_logic_vector'("01"));
				WHEN MULTS_INIT_ST =>
					exp3m_reg_load<='0';
					exp3_load<='0';
					exp2m_reg_load<='0';
					exp2_load<='0';
					exp1m_reg_load<='0';
					exp1_load<='0';
					add_b_mux_sel<='0';
					add1_nd<='0';
					RDY<='0';
					mult1_nd<='1';
					IF ( mult_count0='0' AND mult_count1='0' AND mult_count2='0' AND 
						mult_count3='1' ) THEN
						next_sreg<=MULT1_WAIT_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0000"));
						add_count <= (std_logic_vector'("00"));
					 ELSE
						next_sreg<=MULTS_INIT_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("00"));
						mult_count <= (( std_logic_vector'(mult_count3, mult_count2, 
							mult_count1, mult_count0)) +std_logic_vector'("0001"));
					END IF;
				WHEN OTHERS =>
			END CASE;
		END IF;

		next_add_a_mux_sel1 <= add_a_mux_sel(1);
		next_add_a_mux_sel0 <= add_a_mux_sel(0);
		next_add_count1 <= add_count(1);
		next_add_count0 <= add_count(0);
		next_mult_count3 <= mult_count(3);
		next_mult_count2 <= mult_count(2);
		next_mult_count1 <= mult_count(1);
		next_mult_count0 <= mult_count(0);
	END PROCESS;

	PROCESS (mult_count0,mult_count1,mult_count2,mult_count3,router_sel)
	BEGIN
		router_sel <= (( std_logic_vector'(mult_count3, mult_count2, mult_count1, 
			mult_count0)));
		router_sel0 <= router_sel(0);
		router_sel1 <= router_sel(1);
		router_sel2 <= router_sel(2);
		router_sel3 <= router_sel(3);
	END PROCESS;
END BEHAVIOR;

LIBRARY ieee;
USE ieee.std_logic_1164.all;

LIBRARY ieee;
USE ieee.std_logic_unsigned.all;

ENTITY EXPS_CALC_CONTROL IS
	PORT (add_a_mux_sel : OUT std_logic_vector (1 DOWNTO 0);
		router_sel : OUT std_logic_vector (3 DOWNTO 0);
		CLK,add1_rdy,mult1_rdy,SCLR,START: IN std_logic;
		add1_nd,add_b_mux_sel,exp1_load,exp1m_reg_load,exp2_load,exp2m_reg_load,
			exp3_load,exp3m_reg_load,mult1_nd,RDY : OUT std_logic);
END;

ARCHITECTURE BEHAVIOR OF EXPS_CALC_CONTROL IS
	COMPONENT SHELL_EXPS_CALC_CONTROL
		PORT (CLK,add1_rdy,mult1_rdy,SCLR,START: IN std_logic;
			add1_nd,add_a_mux_sel0,add_a_mux_sel1,add_b_mux_sel,exp1_load,
				exp1m_reg_load,exp2_load,exp2m_reg_load,exp3_load,exp3m_reg_load,mult1_nd,RDY
				,router_sel0,router_sel1,router_sel2,router_sel3 : OUT std_logic);
	END COMPONENT;
BEGIN
	SHELL1_EXPS_CALC_CONTROL : SHELL_EXPS_CALC_CONTROL PORT MAP (CLK=>CLK,
		add1_rdy=>add1_rdy,mult1_rdy=>mult1_rdy,SCLR=>SCLR,START=>START,add1_nd=>
		add1_nd,add_a_mux_sel0=>add_a_mux_sel(0),add_a_mux_sel1=>add_a_mux_sel(1),
		add_b_mux_sel=>add_b_mux_sel,exp1_load=>exp1_load,exp1m_reg_load=>
		exp1m_reg_load,exp2_load=>exp2_load,exp2m_reg_load=>exp2m_reg_load,exp3_load
		=>exp3_load,exp3m_reg_load=>exp3m_reg_load,mult1_nd=>mult1_nd,RDY=>RDY,
		router_sel0=>router_sel(0),router_sel1=>router_sel(1),router_sel2=>router_sel
		(2),router_sel3=>router_sel(3));
END BEHAVIOR;
