--  C:\PROJETO_ISH\MULTILATERATION\NUMERATORS_CALC_CONTROL.vhd
--  VHDL code created by Xilinx's StateCAD 9.1i
--  Thu Jun 28 22:25:58 2007

--  This VHDL code (for use with Xilinx XST) was generated using: 
--  binary encoded state assignment with structured code format.
--  Minimization is enabled,  implied else is enabled, 
--  and outputs are manually optimized.

LIBRARY ieee;
USE ieee.std_logic_1164.all;

LIBRARY ieee;
USE ieee.std_logic_unsigned.all;

ENTITY SHELL_NUMERATORS_CALC_CONTROL IS
	PORT (CLK,add_rdy,mult_rdy,SCLR,start: IN std_logic;
		add_a_mux_sel0,add_a_mux_sel1,add_b_mux_sel0,add_b_mux_sel1,add_nd,
			add_x_tmp_load,add_y_tmp_load,mult_a_mux_sl0,mult_a_mux_sl1,mult_b_mux_sel0,
			mult_b_mux_sel1,mult_b_mux_sel2,mult_b_mux_sel3,mult_nd,num_x_load,num_y_load
			,rdy : OUT std_logic);
END;

ARCHITECTURE BEHAVIOR OF SHELL_NUMERATORS_CALC_CONTROL IS
	SIGNAL sreg : std_logic_vector (5 DOWNTO 0);
	SIGNAL next_sreg : std_logic_vector (5 DOWNTO 0);
	CONSTANT ADD1_INIT_ST : std_logic_vector (5 DOWNTO 0) :="000000";
	CONSTANT ADD1_WAIT_ST : std_logic_vector (5 DOWNTO 0) :="000001";
	CONSTANT ADD3_X_INIT_ST : std_logic_vector (5 DOWNTO 0) :="000010";
	CONSTANT ADD3_Y_INIT_ST : std_logic_vector (5 DOWNTO 0) :="000011";
	CONSTANT ADD3_Y_WAIT : std_logic_vector (5 DOWNTO 0) :="000100";
	CONSTANT ADDS2_WAIT_ST : std_logic_vector (5 DOWNTO 0) :="000101";
	CONSTANT ADDS2_X_INIT_ST : std_logic_vector (5 DOWNTO 0) :="000110";
	CONSTANT ADDS2_X_PPR2_ST : std_logic_vector (5 DOWNTO 0) :="000111";
	CONSTANT ADDS2_X_PPR_ST : std_logic_vector (5 DOWNTO 0) :="001000";
	CONSTANT ADDS2_X_TMP_ST : std_logic_vector (5 DOWNTO 0) :="001001";
	CONSTANT ADDS2_X_WAIT_ST : std_logic_vector (5 DOWNTO 0) :="001010";
	CONSTANT ADDS2_Y_INIT_ST : std_logic_vector (5 DOWNTO 0) :="001011";
	CONSTANT ADDS2_Y_PPR2_ST : std_logic_vector (5 DOWNTO 0) :="001100";
	CONSTANT ADDS2_Y_PPR_ST : std_logic_vector (5 DOWNTO 0) :="001101";
	CONSTANT ADDS2_Y_TMP_ST : std_logic_vector (5 DOWNTO 0) :="001110";
	CONSTANT ADDS2_Y_WAIT2_ST : std_logic_vector (5 DOWNTO 0) :="001111";
	CONSTANT ADDS2_Y_WAIT_ST : std_logic_vector (5 DOWNTO 0) :="010000";
	CONSTANT IDLE_ST : std_logic_vector (5 DOWNTO 0) :="010001";
	CONSTANT MULT_X_1_ST : std_logic_vector (5 DOWNTO 0) :="010010";
	CONSTANT MULT_X_2_ST : std_logic_vector (5 DOWNTO 0) :="010011";
	CONSTANT MULT_Y_1A_ST : std_logic_vector (5 DOWNTO 0) :="010100";
	CONSTANT MULT_Y_1B_ST : std_logic_vector (5 DOWNTO 0) :="010101";
	CONSTANT MULT_Y_2_ST : std_logic_vector (5 DOWNTO 0) :="010110";
	CONSTANT MULTS2_X_INIT_ST : std_logic_vector (5 DOWNTO 0) :="010111";
	CONSTANT MULTS2_X_WAIT_ST : std_logic_vector (5 DOWNTO 0) :="011000";
	CONSTANT MULTS2_Y_INIT_ST : std_logic_vector (5 DOWNTO 0) :="011001";
	CONSTANT MULTS2_Y_PPR_ST : std_logic_vector (5 DOWNTO 0) :="011010";
	CONSTANT MULTS2_Y_WAIT_ST : std_logic_vector (5 DOWNTO 0) :="011011";
	CONSTANT NUM_X_STORE_ST : std_logic_vector (5 DOWNTO 0) :="011100";
	CONSTANT NUM_X_WAIT_ST : std_logic_vector (5 DOWNTO 0) :="011101";
	CONSTANT NUM_Y_STORE_ST : std_logic_vector (5 DOWNTO 0) :="011110";
	CONSTANT NUM_Y_WAIT_ST : std_logic_vector (5 DOWNTO 0) :="011111";
	CONSTANT NUMS_READY_ST : std_logic_vector (5 DOWNTO 0) :="100000";
	CONSTANT WAIT_ADDS_ST : std_logic_vector (5 DOWNTO 0) :="100001";
	CONSTANT WAIT_MULTS2_ST : std_logic_vector (5 DOWNTO 0) :="100010";

	SIGNAL next_add_a_mux_sel0,next_add_a_mux_sel1,next_add_b_mux_sel0,
		next_add_b_mux_sel1,next_add_count0,next_add_count1,next_add_count2,
		next_mult_a_mux_sl0,next_mult_a_mux_sl1,next_mult_count0,next_mult_count1,
		next_mult_count2,next_mult_count3 : std_logic;
	SIGNAL add_a_mux_sel : std_logic_vector (1 DOWNTO 0);
	SIGNAL add_b_mux_sel : std_logic_vector (1 DOWNTO 0);
	SIGNAL add_count : std_logic_vector (2 DOWNTO 0);
	SIGNAL mult_a_mux_sl : std_logic_vector (1 DOWNTO 0);
	SIGNAL mult_b_mux_sel : std_logic_vector (3 DOWNTO 0);
	SIGNAL mult_count : std_logic_vector (3 DOWNTO 0);

	SIGNAL add_count0,add_count1,add_count2,mult_count0,mult_count1,mult_count2,
		mult_count3: std_logic;
BEGIN
	PROCESS (CLK, next_sreg, next_add_a_mux_sel1, next_add_a_mux_sel0, 
		next_add_b_mux_sel1, next_add_b_mux_sel0, next_add_count2, next_add_count1, 
		next_add_count0, next_mult_a_mux_sl1, next_mult_a_mux_sl0, next_mult_count3, 
		next_mult_count2, next_mult_count1, next_mult_count0)
	BEGIN
		IF CLK='1' AND CLK'event THEN
			sreg <= next_sreg;
			add_a_mux_sel1 <= next_add_a_mux_sel1;
			add_a_mux_sel0 <= next_add_a_mux_sel0;
			add_b_mux_sel1 <= next_add_b_mux_sel1;
			add_b_mux_sel0 <= next_add_b_mux_sel0;
			add_count2 <= next_add_count2;
			add_count1 <= next_add_count1;
			add_count0 <= next_add_count0;
			mult_a_mux_sl1 <= next_mult_a_mux_sl1;
			mult_a_mux_sl0 <= next_mult_a_mux_sl0;
			mult_count3 <= next_mult_count3;
			mult_count2 <= next_mult_count2;
			mult_count1 <= next_mult_count1;
			mult_count0 <= next_mult_count0;
		END IF;
	END PROCESS;

	PROCESS (sreg,add_count0,add_count1,add_count2,add_rdy,mult_count0,
		mult_count1,mult_count2,mult_count3,mult_rdy,SCLR,start,add_a_mux_sel,
		add_b_mux_sel,add_count,mult_a_mux_sl,mult_count)
	BEGIN
		next_add_a_mux_sel0 <= '0'; next_add_a_mux_sel1 <= '0'; next_add_b_mux_sel0
			 <= '0'; next_add_b_mux_sel1 <= '0'; next_add_count0 <= '0'; next_add_count1 
			<= '0'; next_add_count2 <= '0'; add_nd <= '0'; add_x_tmp_load <= '0'; 
			add_y_tmp_load <= '0'; next_mult_a_mux_sl0 <= '0'; next_mult_a_mux_sl1 <= 
			'0'; next_mult_count0 <= '0'; next_mult_count1 <= '0'; next_mult_count2 <= 
			'0'; next_mult_count3 <= '0'; mult_nd <= '0'; num_x_load <= '0'; num_y_load 
			<= '0'; rdy <= '0'; 
		add_a_mux_sel<=std_logic_vector'("00"); add_b_mux_sel<=std_logic_vector'(
			"00"); add_count<=std_logic_vector'("000"); mult_a_mux_sl<=std_logic_vector'(
			"00"); mult_count<=std_logic_vector'("0000"); 

		next_sreg<=ADD1_INIT_ST;

		IF ( SCLR='1' ) THEN
			next_sreg<=IDLE_ST;
			rdy<='0';
			num_y_load<='0';
			num_x_load<='0';
			mult_nd<='0';
			add_y_tmp_load<='0';
			add_x_tmp_load<='0';
			add_nd<='0';

			add_a_mux_sel <= (std_logic_vector'("00"));
			add_b_mux_sel <= (std_logic_vector'("00"));
			mult_a_mux_sl <= (std_logic_vector'("00"));
			add_count <= (std_logic_vector'("000"));
			mult_count <= (std_logic_vector'("1111"));
		ELSE
			CASE sreg IS
				WHEN ADD1_INIT_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='1';
					IF ( add_count0='1' AND add_count1='0' AND add_count2='1' ) THEN
						next_sreg<=WAIT_ADDS_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_b_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("000"));
						mult_a_mux_sl <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0110"));
					 ELSE
						next_sreg<=ADD1_WAIT_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_b_mux_sel <= (std_logic_vector'("00"));
						mult_a_mux_sl <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0000"));
						add_count <= (( std_logic_vector'(add_count2, add_count1, add_count0)) 
							+std_logic_vector'("001"));
					END IF;
				WHEN ADD1_WAIT_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					next_sreg<=ADD1_INIT_ST;

					mult_a_mux_sl <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
					add_b_mux_sel <= (std_logic_vector'("00"));
					add_a_mux_sel <= (std_logic_vector'("00"));
					add_count <= (( std_logic_vector'(add_count2, add_count1, add_count0)));
				WHEN ADD3_X_INIT_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='1';
					next_sreg<=ADD3_Y_WAIT;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_b_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("000"));
					mult_a_mux_sl <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
				WHEN ADD3_Y_INIT_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='1';
					next_sreg<=NUM_X_WAIT_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_b_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("000"));
					mult_a_mux_sl <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
				WHEN ADD3_Y_WAIT =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					IF ( add_rdy='1' ) THEN
						next_sreg<=ADD3_Y_INIT_ST;

						add_count <= (std_logic_vector'("000"));
						mult_a_mux_sl <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0000"));
						add_b_mux_sel <= (std_logic_vector'("01"));
						add_a_mux_sel <= (std_logic_vector'("10"));
					 ELSE
						next_sreg<=ADD3_Y_WAIT;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_b_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("000"));
						mult_a_mux_sl <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0000"));
					END IF;
				WHEN ADDS2_WAIT_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					IF ( add_rdy='1' ) THEN
						next_sreg<=ADD3_X_INIT_ST;

						add_count <= (std_logic_vector'("000"));
						mult_a_mux_sl <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0000"));
						add_b_mux_sel <= (std_logic_vector'("01"));
						add_a_mux_sel <= (std_logic_vector'("01"));
					 ELSE
						next_sreg<=ADDS2_WAIT_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_b_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("000"));
						mult_a_mux_sl <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0000"));
					END IF;
				WHEN ADDS2_X_INIT_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='1';
					next_sreg<=ADDS2_X_WAIT_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_b_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("000"));
					mult_a_mux_sl <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
				WHEN ADDS2_X_PPR2_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					next_sreg<=ADDS2_X_INIT_ST;

					add_count <= (std_logic_vector'("000"));
					mult_a_mux_sl <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
					add_b_mux_sel <= (std_logic_vector'("10"));
					add_a_mux_sel <= (std_logic_vector'("01"));
				WHEN ADDS2_X_PPR_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_nd<='0';
					add_x_tmp_load<='1';
					next_sreg<=ADDS2_X_PPR2_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_b_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("000"));
					mult_a_mux_sl <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
				WHEN ADDS2_X_TMP_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_nd<='0';
					add_x_tmp_load<='1';
					next_sreg<=ADDS2_Y_WAIT_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_b_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("000"));
					mult_a_mux_sl <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
				WHEN ADDS2_X_WAIT_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					next_sreg<=ADDS2_X_TMP_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_b_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("000"));
					mult_a_mux_sl <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
				WHEN ADDS2_Y_INIT_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='1';
					next_sreg<=ADDS2_Y_WAIT2_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_b_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("000"));
					mult_a_mux_sl <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
				WHEN ADDS2_Y_PPR2_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					next_sreg<=ADDS2_Y_INIT_ST;

					add_count <= (std_logic_vector'("000"));
					mult_a_mux_sl <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
					add_b_mux_sel <= (std_logic_vector'("10"));
					add_a_mux_sel <= (std_logic_vector'("10"));
				WHEN ADDS2_Y_PPR_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					add_y_tmp_load<='1';
					next_sreg<=ADDS2_Y_PPR2_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_b_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("000"));
					mult_a_mux_sl <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
				WHEN ADDS2_Y_TMP_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					add_y_tmp_load<='1';
					next_sreg<=ADDS2_WAIT_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_b_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("000"));
					mult_a_mux_sl <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
				WHEN ADDS2_Y_WAIT2_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					next_sreg<=ADDS2_Y_TMP_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_b_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("000"));
					mult_a_mux_sl <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
				WHEN ADDS2_Y_WAIT_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					next_sreg<=ADDS2_Y_PPR_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_b_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("000"));
					mult_a_mux_sl <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
				WHEN IDLE_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					IF ( start='1' ) THEN
						next_sreg<=MULT_X_1_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_b_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("000"));
						mult_count <= (( std_logic_vector'(mult_count3, mult_count2, 
							mult_count1, mult_count0)) +std_logic_vector'("0001"));
						mult_a_mux_sl <= (std_logic_vector'("01"));
					 ELSE
						next_sreg<=IDLE_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_b_mux_sel <= (std_logic_vector'("00"));
						mult_a_mux_sl <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("000"));
						mult_count <= (std_logic_vector'("1111"));
					END IF;
				WHEN MULT_X_1_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					mult_nd<='1';
					next_sreg<=MULT_X_2_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_b_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("000"));
					mult_count <= (( std_logic_vector'(mult_count3, mult_count2, mult_count1
						, mult_count0)) +std_logic_vector'("0001"));
					mult_a_mux_sl <= (std_logic_vector'("10"));
				WHEN MULT_X_2_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					mult_nd<='1';
					IF ( mult_count0='1' AND mult_count1='0' AND mult_count2='1' AND 
						mult_count3='0' ) THEN
						next_sreg<=MULT_Y_1A_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_b_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("000"));
						mult_count <= (std_logic_vector'("0000"));
						mult_a_mux_sl <= (std_logic_vector'("10"));
					 ELSE
						next_sreg<=MULT_X_1_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_b_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("000"));
						mult_count <= (( std_logic_vector'(mult_count3, mult_count2, 
							mult_count1, mult_count0)) +std_logic_vector'("0001"));
						mult_a_mux_sl <= (std_logic_vector'("01"));
					END IF;
				WHEN MULT_Y_1A_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					mult_nd<='1';
					next_sreg<=MULT_Y_2_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_b_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("000"));
					mult_count <= (( std_logic_vector'(mult_count3, mult_count2, mult_count1
						, mult_count0)) +std_logic_vector'("0001"));
					mult_a_mux_sl <= (std_logic_vector'("00"));
				WHEN MULT_Y_1B_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					mult_nd<='1';
					next_sreg<=MULT_Y_2_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_b_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("000"));
					mult_count <= (( std_logic_vector'(mult_count3, mult_count2, mult_count1
						, mult_count0)) +std_logic_vector'("0001"));
					mult_a_mux_sl <= (std_logic_vector'("00"));
				WHEN MULT_Y_2_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					mult_nd<='1';
					IF ( mult_count0='1' AND mult_count1='0' AND mult_count2='1' AND 
						mult_count3='0' ) THEN
						next_sreg<=ADD1_INIT_ST;

						mult_a_mux_sl <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0000"));
						add_b_mux_sel <= (std_logic_vector'("00"));
						add_a_mux_sel <= (std_logic_vector'("00"));
						add_count <= (( std_logic_vector'(add_count2, add_count1, add_count0)))
							;
					 ELSE
						next_sreg<=MULT_Y_1B_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_b_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("000"));
						mult_count <= (( std_logic_vector'(mult_count3, mult_count2, 
							mult_count1, mult_count0)) +std_logic_vector'("0001"));
						mult_a_mux_sl <= (std_logic_vector'("10"));
					END IF;
				WHEN MULTS2_X_INIT_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					mult_nd<='1';
					IF ( mult_count0='0' AND mult_count1='0' AND mult_count2='0' AND 
						mult_count3='1' ) THEN
						next_sreg<=MULTS2_Y_PPR_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_b_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("000"));
						mult_a_mux_sl <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0110"));
					 ELSE
						next_sreg<=MULTS2_X_WAIT_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_b_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("000"));
						mult_a_mux_sl <= (std_logic_vector'("00"));
						mult_count <= (( std_logic_vector'(mult_count3, mult_count2, 
							mult_count1, mult_count0)) +std_logic_vector'("0001"));
					END IF;
				WHEN MULTS2_X_WAIT_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					next_sreg<=MULTS2_X_INIT_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_b_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("000"));
					mult_a_mux_sl <= (std_logic_vector'("11"));
					mult_count <= (( std_logic_vector'(mult_count3, mult_count2, mult_count1
						, mult_count0)));
				WHEN MULTS2_Y_INIT_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					mult_nd<='1';
					IF ( mult_count0='0' AND mult_count1='0' AND mult_count2='0' AND 
						mult_count3='1' ) THEN
						next_sreg<=WAIT_MULTS2_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_b_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("000"));
						mult_a_mux_sl <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0000"));
					 ELSE
						next_sreg<=MULTS2_Y_WAIT_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_b_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("000"));
						mult_a_mux_sl <= (std_logic_vector'("00"));
						mult_count <= (( std_logic_vector'(mult_count3, mult_count2, 
							mult_count1, mult_count0)) +std_logic_vector'("0001"));
					END IF;
				WHEN MULTS2_Y_PPR_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					next_sreg<=MULTS2_Y_INIT_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_b_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("000"));
					mult_a_mux_sl <= (std_logic_vector'("11"));
					mult_count <= (( std_logic_vector'(mult_count3, mult_count2, mult_count1
						, mult_count0)));
				WHEN MULTS2_Y_WAIT_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					next_sreg<=MULTS2_Y_INIT_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_b_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("000"));
					mult_a_mux_sl <= (std_logic_vector'("11"));
					mult_count <= (( std_logic_vector'(mult_count3, mult_count2, mult_count1
						, mult_count0)));
				WHEN NUM_X_STORE_ST =>
					rdy<='0';
					num_y_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					num_x_load<='1';
					next_sreg<=NUM_Y_WAIT_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_b_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("000"));
					mult_a_mux_sl <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
				WHEN NUM_X_WAIT_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					IF ( add_rdy='1' ) THEN
						next_sreg<=NUM_X_STORE_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_b_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("000"));
						mult_a_mux_sl <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0000"));
					 ELSE
						next_sreg<=NUM_X_WAIT_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_b_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("000"));
						mult_a_mux_sl <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0000"));
					END IF;
				WHEN NUM_Y_STORE_ST =>
					rdy<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					num_y_load<='1';
					next_sreg<=NUMS_READY_ST;

					add_a_mux_sel <= (std_logic_vector'("00"));
					add_b_mux_sel <= (std_logic_vector'("00"));
					add_count <= (std_logic_vector'("000"));
					mult_a_mux_sl <= (std_logic_vector'("00"));
					mult_count <= (std_logic_vector'("0000"));
				WHEN NUM_Y_WAIT_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					IF ( add_rdy='1' ) THEN
						next_sreg<=NUM_Y_STORE_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_b_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("000"));
						mult_a_mux_sl <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0000"));
					 ELSE
						next_sreg<=NUM_Y_WAIT_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_b_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("000"));
						mult_a_mux_sl <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0000"));
					END IF;
				WHEN NUMS_READY_ST =>
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					rdy<='1';
					IF ( start='1' ) THEN
						next_sreg<=MULT_X_1_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_b_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("000"));
						mult_count <= (( std_logic_vector'(mult_count3, mult_count2, 
							mult_count1, mult_count0)) +std_logic_vector'("0001"));
						mult_a_mux_sl <= (std_logic_vector'("01"));
					 ELSE
						next_sreg<=NUMS_READY_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_b_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("000"));
						mult_a_mux_sl <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0000"));
					END IF;
				WHEN WAIT_ADDS_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					IF ( add_rdy='1' ) THEN
						next_sreg<=MULTS2_X_INIT_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_b_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("000"));
						mult_a_mux_sl <= (std_logic_vector'("11"));
						mult_count <= (( std_logic_vector'(mult_count3, mult_count2, 
							mult_count1, mult_count0)));
					 ELSE
						next_sreg<=WAIT_ADDS_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_b_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("000"));
						mult_a_mux_sl <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0110"));
					END IF;
				WHEN WAIT_MULTS2_ST =>
					rdy<='0';
					num_y_load<='0';
					num_x_load<='0';
					mult_nd<='0';
					add_y_tmp_load<='0';
					add_x_tmp_load<='0';
					add_nd<='0';
					IF ( mult_rdy='1' ) THEN
						next_sreg<=ADDS2_X_PPR_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_b_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("000"));
						mult_a_mux_sl <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0000"));
					 ELSE
						next_sreg<=WAIT_MULTS2_ST;

						add_a_mux_sel <= (std_logic_vector'("00"));
						add_b_mux_sel <= (std_logic_vector'("00"));
						add_count <= (std_logic_vector'("000"));
						mult_a_mux_sl <= (std_logic_vector'("00"));
						mult_count <= (std_logic_vector'("0000"));
					END IF;
				WHEN OTHERS =>
			END CASE;
		END IF;

		next_add_a_mux_sel1 <= add_a_mux_sel(1);
		next_add_a_mux_sel0 <= add_a_mux_sel(0);
		next_add_b_mux_sel1 <= add_b_mux_sel(1);
		next_add_b_mux_sel0 <= add_b_mux_sel(0);
		next_add_count2 <= add_count(2);
		next_add_count1 <= add_count(1);
		next_add_count0 <= add_count(0);
		next_mult_a_mux_sl1 <= mult_a_mux_sl(1);
		next_mult_a_mux_sl0 <= mult_a_mux_sl(0);
		next_mult_count3 <= mult_count(3);
		next_mult_count2 <= mult_count(2);
		next_mult_count1 <= mult_count(1);
		next_mult_count0 <= mult_count(0);
	END PROCESS;

	PROCESS (mult_count0,mult_count1,mult_count2,mult_count3,mult_b_mux_sel)
	BEGIN
		mult_b_mux_sel <= (( std_logic_vector'(mult_count3, mult_count2, 
			mult_count1, mult_count0)));
		mult_b_mux_sel0 <= mult_b_mux_sel(0);
		mult_b_mux_sel1 <= mult_b_mux_sel(1);
		mult_b_mux_sel2 <= mult_b_mux_sel(2);
		mult_b_mux_sel3 <= mult_b_mux_sel(3);
	END PROCESS;
END BEHAVIOR;

LIBRARY ieee;
USE ieee.std_logic_1164.all;

LIBRARY ieee;
USE ieee.std_logic_unsigned.all;

ENTITY NUMERATORS_CALC_CONTROL IS
	PORT (add_a_mux_sel : OUT std_logic_vector (1 DOWNTO 0);
		add_b_mux_sel : OUT std_logic_vector (1 DOWNTO 0);
		mult_a_mux_sl : OUT std_logic_vector (1 DOWNTO 0);
		mult_b_mux_sel : OUT std_logic_vector (3 DOWNTO 0);
		CLK,add_rdy,mult_rdy,SCLR,start: IN std_logic;
		add_nd,add_x_tmp_load,add_y_tmp_load,mult_nd,num_x_load,num_y_load,rdy : 
			OUT std_logic);
END;

ARCHITECTURE BEHAVIOR OF NUMERATORS_CALC_CONTROL IS
	COMPONENT SHELL_NUMERATORS_CALC_CONTROL
		PORT (CLK,add_rdy,mult_rdy,SCLR,start: IN std_logic;
			add_a_mux_sel0,add_a_mux_sel1,add_b_mux_sel0,add_b_mux_sel1,add_nd,
				add_x_tmp_load,add_y_tmp_load,mult_a_mux_sl0,mult_a_mux_sl1,mult_b_mux_sel0,
				mult_b_mux_sel1,mult_b_mux_sel2,mult_b_mux_sel3,mult_nd,num_x_load,num_y_load
				,rdy : OUT std_logic);
	END COMPONENT;
BEGIN
	SHELL1_NUMERATORS_CALC_CONTROL : SHELL_NUMERATORS_CALC_CONTROL PORT MAP (CLK
		=>CLK,add_rdy=>add_rdy,mult_rdy=>mult_rdy,SCLR=>SCLR,start=>start,
		add_a_mux_sel0=>add_a_mux_sel(0),add_a_mux_sel1=>add_a_mux_sel(1),
		add_b_mux_sel0=>add_b_mux_sel(0),add_b_mux_sel1=>add_b_mux_sel(1),add_nd=>
		add_nd,add_x_tmp_load=>add_x_tmp_load,add_y_tmp_load=>add_y_tmp_load,
		mult_a_mux_sl0=>mult_a_mux_sl(0),mult_a_mux_sl1=>mult_a_mux_sl(1),
		mult_b_mux_sel0=>mult_b_mux_sel(0),mult_b_mux_sel1=>mult_b_mux_sel(1),
		mult_b_mux_sel2=>mult_b_mux_sel(2),mult_b_mux_sel3=>mult_b_mux_sel(3),mult_nd
		=>mult_nd,num_x_load=>num_x_load,num_y_load=>num_y_load,rdy=>rdy);
END BEHAVIOR;
