--------------------------------------------------------------------------------
-- Copyright (c) 1995-2007 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 9.1.03i
--  \   \         Application : sch2vhdl
--  /   /         Filename : exps_calc.vhf
-- /___/   /\     Timestamp : 07/14/2007 02:30:52
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: C:\Xilinx91i\bin\nt\sch2vhdl.exe -intstyle ise -family virtex4 -flat -suppress -w C:/xps/isha/pcores/multilateration_ip_v1_00_a/devl/projnav/exps_calc.sch exps_calc.vhf
--Design Name: exps_calc
--Device: virtex4
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesis and simulted, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity exps_calc is
   port ( a11   : in    std_logic_vector (31 downto 0); 
          a12   : in    std_logic_vector (31 downto 0); 
          a21   : in    std_logic_vector (31 downto 0); 
          a22   : in    std_logic_vector (31 downto 0); 
          a31   : in    std_logic_vector (31 downto 0); 
          a32   : in    std_logic_vector (31 downto 0); 
          clk   : in    std_logic; 
          reset : in    std_logic; 
          start : in    std_logic; 
          exp1  : out   std_logic_vector (31 downto 0); 
          exp2  : out   std_logic_vector (31 downto 0); 
          exp3  : out   std_logic_vector (31 downto 0); 
          rdy   : out   std_logic);
end exps_calc;

architecture BEHAVIORAL of exps_calc is
   signal add_a_val      : std_logic_vector (31 downto 0);
   signal add_b_val      : std_logic_vector (31 downto 0);
   signal add1_rdy       : std_logic;
   signal add1_res       : std_logic_vector (31 downto 0);
   signal dbg_add_nd     : std_logic;
   signal dbg_exp1m_load : std_logic;
   signal dbg_exp1_ld    : std_logic;
   signal dbg_mult_nd    : std_logic;
   signal exp1m_reg      : std_logic_vector (31 downto 0);
   signal exp2m_reg      : std_logic_vector (31 downto 0);
   signal exp3m_reg      : std_logic_vector (31 downto 0);
   signal mult_a         : std_logic_vector (31 downto 0);
   signal mult_b         : std_logic_vector (31 downto 0);
   signal mult1_rdy      : std_logic;
   signal mult1_res      : std_logic_vector (31 downto 0);
   signal XLXN_205       : std_logic_vector (31 downto 0);
   signal XLXN_251       : std_logic;
   signal XLXN_252       : std_logic;
   signal XLXN_276       : std_logic_vector (3 downto 0);
   signal XLXN_284       : std_logic;
   signal XLXN_285       : std_logic;
   signal XLXN_294       : std_logic_vector (1 downto 0);
   signal XLXN_295       : std_logic;
   component mux32_3
      port ( a        : in    std_logic_vector (31 downto 0); 
             b        : in    std_logic_vector (31 downto 0); 
             c        : in    std_logic_vector (31 downto 0); 
             selector : in    std_logic_vector (1 downto 0); 
             selected : out   std_logic_vector (31 downto 0));
   end component;
   
   component mux32_2
      port ( SELECTOR : in    std_logic; 
             A        : in    std_logic_vector (31 downto 0); 
             B        : in    std_logic_vector (31 downto 0); 
             OUTPUT   : out   std_logic_vector (31 downto 0));
   end component;
   
   component add_fp
      port ( a             : in    std_logic_vector (31 downto 0); 
             b             : in    std_logic_vector (31 downto 0); 
             operation_nd  : in    std_logic; 
             operation_rfd : out   std_logic; 
             sclr          : in    std_logic; 
             clk           : in    std_logic; 
             result        : out   std_logic_vector (31 downto 0); 
             rdy           : out   std_logic);
   end component;
   
   component EXPS_CALC_CONTROL
      port ( CLK            : in    std_logic; 
             add1_rdy       : in    std_logic; 
             mult1_rdy      : in    std_logic; 
             SCLR           : in    std_logic; 
             START          : in    std_logic; 
             add1_nd        : out   std_logic; 
             add_b_mux_sel  : out   std_logic; 
             exp1_load      : out   std_logic; 
             exp1m_reg_load : out   std_logic; 
             exp2_load      : out   std_logic; 
             exp2m_reg_load : out   std_logic; 
             exp3_load      : out   std_logic; 
             exp3m_reg_load : out   std_logic; 
             mult1_nd       : out   std_logic; 
             RDY            : out   std_logic; 
             add_a_mux_sel  : out   std_logic_vector (1 downto 0); 
             router_sel     : out   std_logic_vector (3 downto 0));
   end component;
   
   component reg32
      port ( LOAD   : in    std_logic; 
             RESET  : in    std_logic; 
             CLK    : in    std_logic; 
             INPUT  : in    std_logic_vector (31 downto 0); 
             OUTPUT : out   std_logic_vector (31 downto 0));
   end component;
   
   component mult_fp
      port ( a             : in    std_logic_vector (31 downto 0); 
             b             : in    std_logic_vector (31 downto 0); 
             operation_nd  : in    std_logic; 
             operation_rfd : out   std_logic; 
             sclr          : in    std_logic; 
             clk           : in    std_logic; 
             result        : out   std_logic_vector (31 downto 0); 
             rdy           : out   std_logic);
   end component;
   
   component router_6_2
      port ( a11      : in    std_logic_vector (31 downto 0); 
             a12      : in    std_logic_vector (31 downto 0); 
             a21      : in    std_logic_vector (31 downto 0); 
             a22      : in    std_logic_vector (31 downto 0); 
             a31      : in    std_logic_vector (31 downto 0); 
             a32      : in    std_logic_vector (31 downto 0); 
             selector : in    std_logic_vector (3 downto 0); 
             a        : out   std_logic_vector (31 downto 0); 
             b        : out   std_logic_vector (31 downto 0));
   end component;
   
   component signal_inversor_fp
      port ( input_val  : in    std_logic_vector (31 downto 0); 
             output_val : out   std_logic_vector (31 downto 0));
   end component;
   
begin
   add_a_mux : mux32_3
      port map (a(31 downto 0)=>exp1m_reg(31 downto 0),
                b(31 downto 0)=>exp2m_reg(31 downto 0),
                c(31 downto 0)=>exp3m_reg(31 downto 0),
                selector(1 downto 0)=>XLXN_294(1 downto 0),
                selected(31 downto 0)=>add_a_val(31 downto 0));
   
   add_b_mux : mux32_2
      port map (A(31 downto 0)=>mult1_res(31 downto 0),
                B(31 downto 0)=>add1_res(31 downto 0),
                SELECTOR=>XLXN_295,
                OUTPUT(31 downto 0)=>add_b_val(31 downto 0));
   
   add_1 : add_fp
      port map (a(31 downto 0)=>add_a_val(31 downto 0),
                b(31 downto 0)=>add_b_val(31 downto 0),
                clk=>clk,
                operation_nd=>dbg_add_nd,
                sclr=>reset,
                operation_rfd=>open,
                rdy=>add1_rdy,
                result(31 downto 0)=>add1_res(31 downto 0));
   
   CTRL : EXPS_CALC_CONTROL
      port map (add1_rdy=>add1_rdy,
                CLK=>clk,
                mult1_rdy=>mult1_rdy,
                SCLR=>reset,
                START=>start,
                add_a_mux_sel(1 downto 0)=>XLXN_294(1 downto 0),
                add_b_mux_sel=>XLXN_295,
                add1_nd=>dbg_add_nd,
                exp1m_reg_load=>dbg_exp1m_load,
                exp1_load=>dbg_exp1_ld,
                exp2m_reg_load=>XLXN_285,
                exp2_load=>XLXN_251,
                exp3m_reg_load=>XLXN_284,
                exp3_load=>XLXN_252,
                mult1_nd=>dbg_mult_nd,
                RDY=>rdy,
                router_sel(3 downto 0)=>XLXN_276(3 downto 0));
   
   exp1_mult : reg32
      port map (CLK=>clk,
                INPUT(31 downto 0)=>mult1_res(31 downto 0),
                LOAD=>dbg_exp1m_load,
                RESET=>reset,
                OUTPUT(31 downto 0)=>exp1m_reg(31 downto 0));
   
   exp1_value : reg32
      port map (CLK=>clk,
                INPUT(31 downto 0)=>add1_res(31 downto 0),
                LOAD=>dbg_exp1_ld,
                RESET=>reset,
                OUTPUT(31 downto 0)=>exp1(31 downto 0));
   
   exp2_mult : reg32
      port map (CLK=>clk,
                INPUT(31 downto 0)=>mult1_res(31 downto 0),
                LOAD=>XLXN_285,
                RESET=>reset,
                OUTPUT(31 downto 0)=>exp2m_reg(31 downto 0));
   
   exp2_value : reg32
      port map (CLK=>clk,
                INPUT(31 downto 0)=>add1_res(31 downto 0),
                LOAD=>XLXN_251,
                RESET=>reset,
                OUTPUT(31 downto 0)=>exp2(31 downto 0));
   
   exp3_mult : reg32
      port map (CLK=>clk,
                INPUT(31 downto 0)=>mult1_res(31 downto 0),
                LOAD=>XLXN_284,
                RESET=>reset,
                OUTPUT(31 downto 0)=>exp3m_reg(31 downto 0));
   
   exp3_value : reg32
      port map (CLK=>clk,
                INPUT(31 downto 0)=>XLXN_205(31 downto 0),
                LOAD=>XLXN_252,
                RESET=>reset,
                OUTPUT(31 downto 0)=>exp3(31 downto 0));
   
   mult_fp_1 : mult_fp
      port map (a(31 downto 0)=>mult_a(31 downto 0),
                b(31 downto 0)=>mult_b(31 downto 0),
                clk=>clk,
                operation_nd=>dbg_mult_nd,
                sclr=>reset,
                operation_rfd=>open,
                rdy=>mult1_rdy,
                result(31 downto 0)=>mult1_res(31 downto 0));
   
   router : router_6_2
      port map (a11(31 downto 0)=>a11(31 downto 0),
                a12(31 downto 0)=>a12(31 downto 0),
                a21(31 downto 0)=>a21(31 downto 0),
                a22(31 downto 0)=>a22(31 downto 0),
                a31(31 downto 0)=>a31(31 downto 0),
                a32(31 downto 0)=>a32(31 downto 0),
                selector(3 downto 0)=>XLXN_276(3 downto 0),
                a(31 downto 0)=>mult_a(31 downto 0),
                b(31 downto 0)=>mult_b(31 downto 0));
   
   sign_inv_fp : signal_inversor_fp
      port map (input_val(31 downto 0)=>add1_res(31 downto 0),
                output_val(31 downto 0)=>XLXN_205(31 downto 0));
   
end BEHAVIORAL;


