VERSION 6
BEGIN SCHEMATIC
    BEGIN ATTR DeviceFamilyName "virtex4"
        DELETE all:0
        EDITNAME all:0
        EDITTRAIT all:0
    END ATTR
    BEGIN NETLIST
        SIGNAL clk
        SIGNAL div_factor(31:0)
        SIGNAL XLXN_19(31:0)
        SIGNAL reset
        SIGNAL XLXN_27(31:0)
        SIGNAL XLXN_29
        SIGNAL x(31:0)
        SIGNAL XLXN_43(31:0)
        SIGNAL y(31:0)
        SIGNAL num_x(31:0)
        SIGNAL num_y(31:0)
        SIGNAL start
        SIGNAL XLXN_48
        SIGNAL XLXN_52
        SIGNAL XLXN_53
        SIGNAL XLXN_54
        SIGNAL rdy
        PORT Input clk
        PORT Input div_factor(31:0)
        PORT Input reset
        PORT Output x(31:0)
        PORT Output y(31:0)
        PORT Input num_x(31:0)
        PORT Input num_y(31:0)
        PORT Input start
        PORT Output rdy
        BEGIN BLOCKDEF mux32_2
            TIMESTAMP 2007 7 2 20 34 20
            RECTANGLE N 64 -192 368 0 
            LINE N 64 -160 0 -160 
            RECTANGLE N 0 -108 64 -84 
            LINE N 64 -96 0 -96 
            RECTANGLE N 0 -44 64 -20 
            LINE N 64 -32 0 -32 
            RECTANGLE N 368 -172 432 -148 
            LINE N 368 -160 432 -160 
        END BLOCKDEF
        BEGIN BLOCKDEF reg32
            TIMESTAMP 2007 6 27 20 6 4
            RECTANGLE N 64 -256 368 0 
            LINE N 64 -224 0 -224 
            LINE N 64 -160 0 -160 
            LINE N 64 -96 0 -96 
            RECTANGLE N 0 -44 64 -20 
            LINE N 64 -32 0 -32 
            RECTANGLE N 368 -236 432 -212 
            LINE N 368 -224 432 -224 
        END BLOCKDEF
        BEGIN BLOCKDEF div_fp
            TIMESTAMP 2007 7 14 3 18 54
            RECTANGLE N 32 32 480 384 
            BEGIN LINE W 0 80 32 80 
            END LINE
            BEGIN LINE W 0 112 32 112 
            END LINE
            LINE N 0 208 32 208 
            LINE N 0 240 32 240 
            LINE N 0 304 32 304 
            LINE N 144 416 144 384 
            BEGIN LINE W 512 80 480 80 
            END LINE
            LINE N 512 240 480 240 
        END BLOCKDEF
        BEGIN BLOCKDEF XY_CALC_CONTROL
            TIMESTAMP 2007 6 29 1 27 4
            RECTANGLE N 64 -320 320 0 
            LINE N 64 -288 0 -288 
            LINE N 64 -208 0 -208 
            LINE N 64 -128 0 -128 
            LINE N 64 -48 0 -48 
            LINE N 320 -288 384 -288 
            LINE N 320 -224 384 -224 
            LINE N 320 -160 384 -160 
            LINE N 320 -96 384 -96 
            LINE N 320 -32 384 -32 
        END BLOCKDEF
        BEGIN BLOCK div_res_temp_reg reg32
            PIN LOAD XLXN_29
            PIN RESET reset
            PIN CLK clk
            PIN INPUT(31:0) XLXN_27(31:0)
            PIN OUTPUT(31:0) XLXN_43(31:0)
        END BLOCK
        BEGIN BLOCK x_reg reg32
            PIN LOAD XLXN_54
            PIN RESET reset
            PIN CLK clk
            PIN INPUT(31:0) XLXN_43(31:0)
            PIN OUTPUT(31:0) x(31:0)
        END BLOCK
        BEGIN BLOCK y_reg reg32
            PIN LOAD XLXN_53
            PIN RESET reset
            PIN CLK clk
            PIN INPUT(31:0) XLXN_43(31:0)
            PIN OUTPUT(31:0) y(31:0)
        END BLOCK
        BEGIN BLOCK div_a_mux mux32_2
            PIN SELECTOR XLXN_48
            PIN A(31:0) num_x(31:0)
            PIN B(31:0) num_y(31:0)
            PIN OUTPUT(31:0) XLXN_19(31:0)
        END BLOCK
        BEGIN BLOCK div_fp_1 div_fp
            PIN a(31:0) XLXN_19(31:0)
            PIN b(31:0) div_factor(31:0)
            PIN operation_nd XLXN_52
            PIN operation_rfd
            PIN sclr reset
            PIN clk clk
            PIN result(31:0) XLXN_27(31:0)
            PIN rdy XLXN_29
        END BLOCK
        BEGIN BLOCK control XY_CALC_CONTROL
            PIN CLK clk
            PIN div_rdy XLXN_29
            PIN sclr reset
            PIN start start
            PIN div_a_mux_sel XLXN_48
            PIN div_nd XLXN_52
            PIN rdy rdy
            PIN x_reg_load XLXN_54
            PIN y_reg_load XLXN_53
        END BLOCK
    END NETLIST
    BEGIN SHEET 1 3520 2720
        BEGIN BRANCH XLXN_19(31:0)
            WIRE 832 720 1360 720
        END BRANCH
        BEGIN BRANCH XLXN_27(31:0)
            WIRE 1872 720 2128 720
        END BRANCH
        BEGIN BRANCH XLXN_29
            WIRE 480 2000 544 2000
            WIRE 480 2000 480 2272
            WIRE 480 2272 2000 2272
            WIRE 1872 880 2000 880
            WIRE 2000 880 2000 2272
            WIRE 2000 528 2000 880
            WIRE 2000 528 2128 528
        END BRANCH
        BEGIN BRANCH x(31:0)
            WIRE 3360 336 3376 336
        END BRANCH
        BEGIN BRANCH XLXN_43(31:0)
            WIRE 2560 528 2800 528
            WIRE 2800 528 2928 528
            WIRE 2800 528 2800 1024
            WIRE 2800 1024 2912 1024
        END BRANCH
        IOMARKER 3376 336 x(31:0) R0 28
        BEGIN BRANCH y(31:0)
            WIRE 3344 832 3360 832
        END BRANCH
        IOMARKER 3360 832 y(31:0) R0 28
        BEGIN BRANCH num_x(31:0)
            WIRE 240 784 400 784
        END BRANCH
        BEGIN BRANCH num_y(31:0)
            WIRE 240 848 400 848
        END BRANCH
        BEGIN INSTANCE div_a_mux 400 880 R0
        END INSTANCE
        IOMARKER 240 784 num_x(31:0) R180 28
        IOMARKER 240 848 num_y(31:0) R180 28
        IOMARKER 272 1024 div_factor(31:0) R180 28
        BEGIN BRANCH div_factor(31:0)
            WIRE 272 1024 848 1024
            WIRE 848 752 848 1024
            WIRE 848 752 1360 752
        END BRANCH
        IOMARKER 160 1648 clk R180 28
        IOMARKER 176 1568 reset R180 28
        BEGIN BRANCH reset
            WIRE 176 1568 336 1568
            WIRE 336 1568 1344 1568
            WIRE 1344 1568 2032 1568
            WIRE 336 1568 336 2080
            WIRE 336 2080 544 2080
            WIRE 1344 944 1360 944
            WIRE 1344 944 1344 1568
            WIRE 2032 592 2128 592
            WIRE 2032 592 2032 896
            WIRE 2032 896 2032 1568
            WIRE 2032 896 2656 896
            WIRE 2656 896 2912 896
            WIRE 2656 400 2928 400
            WIRE 2656 400 2656 896
        END BRANCH
        BEGIN INSTANCE div_res_temp_reg 2128 752 R0
        END INSTANCE
        BEGIN INSTANCE div_fp_1 1360 640 R0
        END INSTANCE
        BEGIN BRANCH clk
            WIRE 160 1648 432 1648
            WIRE 432 1648 1504 1648
            WIRE 1504 1648 2064 1648
            WIRE 432 1648 432 1920
            WIRE 432 1920 544 1920
            WIRE 1504 1056 1504 1648
            WIRE 2064 656 2128 656
            WIRE 2064 656 2064 960
            WIRE 2064 960 2688 960
            WIRE 2688 960 2912 960
            WIRE 2064 960 2064 1648
            WIRE 2688 464 2928 464
            WIRE 2688 464 2688 960
        END BRANCH
        BEGIN BRANCH start
            WIRE 352 2160 544 2160
        END BRANCH
        BEGIN BRANCH XLXN_48
            WIRE 384 720 400 720
            WIRE 384 720 384 960
            WIRE 384 960 992 960
            WIRE 992 960 992 1920
            WIRE 928 1920 992 1920
        END BRANCH
        IOMARKER 352 2160 start R180 28
        BEGIN INSTANCE control 544 2208 R0
        END INSTANCE
        BEGIN BRANCH XLXN_52
            WIRE 928 1984 1136 1984
            WIRE 1136 848 1136 1984
            WIRE 1136 848 1360 848
        END BRANCH
        BEGIN BRANCH XLXN_53
            WIRE 928 2176 2480 2176
            WIRE 2480 832 2480 2176
            WIRE 2480 832 2912 832
        END BRANCH
        BEGIN INSTANCE y_reg 2912 1056 R0
        END INSTANCE
        BEGIN INSTANCE x_reg 2928 560 R0
        END INSTANCE
        BEGIN BRANCH XLXN_54
            WIRE 928 2112 2608 2112
            WIRE 2608 336 2608 2112
            WIRE 2608 336 2928 336
        END BRANCH
        IOMARKER 1104 2048 rdy R0 28
        BEGIN BRANCH rdy
            WIRE 928 2048 1104 2048
        END BRANCH
    END SHEET
END SCHEMATIC
