onerror {resume}
quietly WaveActivateNextPane {} 0
add wave -noupdate -divider {System Level Ports}
add wave -noupdate -format Logic /bfm_system/sys_clk
add wave -noupdate -format Logic /bfm_system/sys_reset
add wave -noupdate -divider {OPB Bus Master Signals}
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/opb_bus_M_ABus
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/opb_bus_M_BE
add wave -noupdate -format Logic /bfm_system/opb_bus_M_busLock
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/opb_bus_M_DBus
add wave -noupdate -format Logic /bfm_system/opb_bus_M_request
add wave -noupdate -format Logic /bfm_system/opb_bus_M_RNW
add wave -noupdate -format Logic /bfm_system/opb_bus_M_select
add wave -noupdate -format Logic /bfm_system/opb_bus_M_seqAddr
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/opb_bus_OPB_DBus
add wave -noupdate -format Logic /bfm_system/opb_bus_OPB_errAck
add wave -noupdate -format Logic /bfm_system/opb_bus_OPB_MGrant
add wave -noupdate -format Logic /bfm_system/opb_bus_OPB_retry
add wave -noupdate -format Logic /bfm_system/opb_bus_OPB_timeout
add wave -noupdate -format Logic /bfm_system/opb_bus_OPB_xferAck
add wave -noupdate -divider {OPB Bus Slave Signals}
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/opb_bus_Sl_DBus
add wave -noupdate -format Logic /bfm_system/opb_bus_Sl_errAck
add wave -noupdate -format Logic /bfm_system/opb_bus_Sl_retry
add wave -noupdate -format Logic /bfm_system/opb_bus_Sl_toutSup
add wave -noupdate -format Logic /bfm_system/opb_bus_Sl_xferAck
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/opb_bus_OPB_ABus
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/opb_bus_OPB_BE
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/opb_bus_OPB_DBus
add wave -noupdate -format Logic /bfm_system/opb_bus_OPB_RNW
add wave -noupdate -format Logic /bfm_system/opb_bus_OPB_select
add wave -noupdate -format Logic /bfm_system/opb_bus_OPB_seqAddr
add wave -noupdate -divider {BFM Synch Bus Signals}
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/synch_bus/synch_bus/FROM_SYNCH_OUT
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/synch_bus/synch_bus/TO_SYNCH_IN
add wave -noupdate -divider {multilateration_ip Interface Signals}
add wave -noupdate -format Logic /bfm_system/my_core/my_core/uut/OPB_Clk
add wave -noupdate -format Logic /bfm_system/my_core/my_core/uut/OPB_Rst
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/Sl_DBus
add wave -noupdate -format Logic /bfm_system/my_core/my_core/uut/Sl_errAck
add wave -noupdate -format Logic /bfm_system/my_core/my_core/uut/Sl_retry
add wave -noupdate -format Logic /bfm_system/my_core/my_core/uut/Sl_toutSup
add wave -noupdate -format Logic /bfm_system/my_core/my_core/uut/Sl_xferAck
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/OPB_ABus
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/OPB_BE
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/OPB_DBus
add wave -noupdate -format Logic /bfm_system/my_core/my_core/uut/OPB_RNW
add wave -noupdate -format Logic /bfm_system/my_core/my_core/uut/OPB_select
add wave -noupdate -format Logic /bfm_system/my_core/my_core/uut/OPB_seqAddr
add wave -noupdate -divider {User Logic Interface Signals}
add wave -noupdate -format Logic /bfm_system/my_core/my_core/uut/user_logic_i/Bus2IP_Clk
add wave -noupdate -format Logic /bfm_system/my_core/my_core/uut/user_logic_i/Bus2IP_Reset
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/user_logic_i/Bus2IP_Data
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/user_logic_i/Bus2IP_BE
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/user_logic_i/Bus2IP_RdCE
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/user_logic_i/Bus2IP_WrCE
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/user_logic_i/IP2Bus_Data
add wave -noupdate -format Logic /bfm_system/my_core/my_core/uut/user_logic_i/IP2Bus_Ack
add wave -noupdate -format Logic /bfm_system/my_core/my_core/uut/user_logic_i/IP2Bus_Retry
add wave -noupdate -format Logic /bfm_system/my_core/my_core/uut/user_logic_i/IP2Bus_Error
add wave -noupdate -format Logic /bfm_system/my_core/my_core/uut/user_logic_i/IP2Bus_ToutSup
add wave -noupdate -divider {User Logic Internal Slave Space Signals}
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/user_logic_i/slv_reg0
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/user_logic_i/slv_reg1
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/user_logic_i/slv_reg2
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/user_logic_i/slv_reg3
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/user_logic_i/slv_reg4
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/user_logic_i/slv_reg5
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/user_logic_i/slv_reg6
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/user_logic_i/slv_reg7
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/user_logic_i/slv_reg8
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/user_logic_i/slv_reg9
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/user_logic_i/slv_reg10
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/user_logic_i/slv_reg11
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/user_logic_i/slv_reg12
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/user_logic_i/slv_reg_write_select
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/user_logic_i/slv_reg_read_select
add wave -noupdate -format Literal -radix hexadecimal /bfm_system/my_core/my_core/uut/user_logic_i/slv_ip2bus_data
add wave -noupdate -format Logic /bfm_system/my_core/my_core/uut/user_logic_i/slv_read_ack
add wave -noupdate -format Logic /bfm_system/my_core/my_core/uut/user_logic_i/slv_write_ack
TreeUpdate [SetDefaultTree]
WaveRestoreCursors {200 ns}
WaveRestoreZoom {0 ns} {2 us}
configure wave -namecolwidth 200
configure wave -valuecolwidth 100
configure wave -justifyvalue left
configure wave -signalnamewidth 1
configure wave -snapdistance 10
configure wave -datasetprefix 0
configure wave -rowmargin 4
configure wave -childrowmargin 2
