VERSION 6
BEGIN SCHEMATIC
    BEGIN ATTR DeviceFamilyName "virtex4"
        DELETE all:0
        EDITNAME all:0
        EDITTRAIT all:0
    END ATTR
    BEGIN NETLIST
        SIGNAL CLK
        SIGNAL RESET
        SIGNAL B31(31:0)
        SIGNAL B21(31:0)
        SIGNAL B11(31:0)
        SIGNAL A21(31:0)
        SIGNAL A22(31:0)
        SIGNAL A31(31:0)
        SIGNAL A32(31:0)
        SIGNAL A12(31:0)
        SIGNAL A11(31:0)
        SIGNAL XLXN_1(31:0)
        SIGNAL XLXN_3(31:0)
        SIGNAL XLXN_2(31:0)
        SIGNAL XLXN_4(31:0)
        SIGNAL XLXN_5(31:0)
        SIGNAL XLXN_14(31:0)
        SIGNAL x(31:0)
        SIGNAL y(31:0)
        SIGNAL XLXN_22
        SIGNAL XLXN_23
        SIGNAL XLXN_24
        SIGNAL XLXN_41
        SIGNAL XLXN_42
        SIGNAL XLXN_43
        SIGNAL XLXN_50
        SIGNAL rdy
        SIGNAL start
        SIGNAL XLXN_58
        PORT Input CLK
        PORT Input RESET
        PORT Input B31(31:0)
        PORT Input B21(31:0)
        PORT Input B11(31:0)
        PORT Input A21(31:0)
        PORT Input A22(31:0)
        PORT Input A31(31:0)
        PORT Input A32(31:0)
        PORT Input A12(31:0)
        PORT Input A11(31:0)
        PORT Output x(31:0)
        PORT Output y(31:0)
        PORT Output rdy
        PORT Input start
        BEGIN BLOCKDEF numerators_calc
            TIMESTAMP 2007 6 29 1 33 6
            RECTANGLE N 64 -960 320 0 
            RECTANGLE N 0 -940 64 -916 
            LINE N 64 -928 0 -928 
            RECTANGLE N 0 -876 64 -852 
            LINE N 64 -864 0 -864 
            RECTANGLE N 0 -812 64 -788 
            LINE N 64 -800 0 -800 
            RECTANGLE N 0 -748 64 -724 
            LINE N 64 -736 0 -736 
            RECTANGLE N 0 -684 64 -660 
            LINE N 64 -672 0 -672 
            RECTANGLE N 0 -620 64 -596 
            LINE N 64 -608 0 -608 
            RECTANGLE N 0 -556 64 -532 
            LINE N 64 -544 0 -544 
            RECTANGLE N 0 -492 64 -468 
            LINE N 64 -480 0 -480 
            RECTANGLE N 0 -428 64 -404 
            LINE N 64 -416 0 -416 
            RECTANGLE N 0 -364 64 -340 
            LINE N 64 -352 0 -352 
            RECTANGLE N 0 -300 64 -276 
            LINE N 64 -288 0 -288 
            RECTANGLE N 0 -236 64 -212 
            LINE N 64 -224 0 -224 
            LINE N 64 -160 0 -160 
            LINE N 64 -96 0 -96 
            LINE N 64 -32 0 -32 
            RECTANGLE N 320 -940 384 -916 
            LINE N 320 -928 384 -928 
            RECTANGLE N 320 -492 384 -468 
            LINE N 320 -480 384 -480 
            LINE N 320 -32 384 -32 
        END BLOCKDEF
        BEGIN BLOCKDEF exps_calc
            TIMESTAMP 2007 6 29 1 32 36
            RECTANGLE N 64 -576 320 0 
            RECTANGLE N 0 -556 64 -532 
            LINE N 64 -544 0 -544 
            RECTANGLE N 0 -492 64 -468 
            LINE N 64 -480 0 -480 
            RECTANGLE N 0 -428 64 -404 
            LINE N 64 -416 0 -416 
            RECTANGLE N 0 -364 64 -340 
            LINE N 64 -352 0 -352 
            RECTANGLE N 0 -300 64 -276 
            LINE N 64 -288 0 -288 
            RECTANGLE N 0 -236 64 -212 
            LINE N 64 -224 0 -224 
            LINE N 64 -160 0 -160 
            LINE N 64 -96 0 -96 
            LINE N 64 -32 0 -32 
            RECTANGLE N 320 -556 384 -532 
            LINE N 320 -544 384 -544 
            RECTANGLE N 320 -396 384 -372 
            LINE N 320 -384 384 -384 
            RECTANGLE N 320 -236 384 -212 
            LINE N 320 -224 384 -224 
            LINE N 320 -64 384 -64 
        END BLOCKDEF
        BEGIN BLOCKDEF div_factor_calc
            TIMESTAMP 2007 6 29 1 32 46
            RECTANGLE N 64 -384 400 0 
            RECTANGLE N 0 -364 64 -340 
            LINE N 64 -352 0 -352 
            RECTANGLE N 0 -300 64 -276 
            LINE N 64 -288 0 -288 
            RECTANGLE N 0 -236 64 -212 
            LINE N 64 -224 0 -224 
            LINE N 64 -160 0 -160 
            LINE N 64 -96 0 -96 
            LINE N 64 -32 0 -32 
            RECTANGLE N 400 -364 464 -340 
            LINE N 400 -352 464 -352 
            LINE N 400 -32 464 -32 
        END BLOCKDEF
        BEGIN BLOCKDEF xy_calc
            TIMESTAMP 2007 6 29 1 33 10
            RECTANGLE N 64 -384 320 0 
            LINE N 64 -352 0 -352 
            RECTANGLE N 0 -300 64 -276 
            LINE N 64 -288 0 -288 
            LINE N 64 -224 0 -224 
            RECTANGLE N 0 -172 64 -148 
            LINE N 64 -160 0 -160 
            RECTANGLE N 0 -108 64 -84 
            LINE N 64 -96 0 -96 
            LINE N 64 -32 0 -32 
            RECTANGLE N 320 -364 384 -340 
            LINE N 320 -352 384 -352 
            RECTANGLE N 320 -204 384 -180 
            LINE N 320 -192 384 -192 
            LINE N 320 -32 384 -32 
        END BLOCKDEF
        BEGIN BLOCKDEF MULTILATERATION_CONTROL
            TIMESTAMP 2007 6 29 1 27 12
            RECTANGLE N 64 -448 400 0 
            LINE N 64 -416 0 -416 
            LINE N 64 -352 0 -352 
            LINE N 64 -288 0 -288 
            LINE N 64 -224 0 -224 
            LINE N 64 -160 0 -160 
            LINE N 64 -96 0 -96 
            LINE N 64 -32 0 -32 
            LINE N 400 -416 464 -416 
            LINE N 400 -320 464 -320 
            LINE N 400 -224 464 -224 
            LINE N 400 -128 464 -128 
            LINE N 400 -32 464 -32 
        END BLOCKDEF
        BEGIN BLOCK divfaccalc_1 div_factor_calc
            PIN EXP1(31:0) XLXN_1(31:0)
            PIN EXP2(31:0) XLXN_2(31:0)
            PIN EXP3(31:0) XLXN_3(31:0)
            PIN CLK CLK
            PIN RESET RESET
            PIN START XLXN_42
            PIN DIVFACTOR(31:0) XLXN_14(31:0)
            PIN RDY XLXN_24
        END BLOCK
        BEGIN BLOCK exps_calc_1 exps_calc
            PIN a11(31:0) A11(31:0)
            PIN a12(31:0) A12(31:0)
            PIN a21(31:0) A21(31:0)
            PIN a22(31:0) A22(31:0)
            PIN a31(31:0) A31(31:0)
            PIN a32(31:0) A32(31:0)
            PIN reset RESET
            PIN clk CLK
            PIN start XLXN_58
            PIN exp1(31:0) XLXN_1(31:0)
            PIN exp3(31:0) XLXN_3(31:0)
            PIN exp2(31:0) XLXN_2(31:0)
            PIN rdy XLXN_22
        END BLOCK
        BEGIN BLOCK num_calc_1 numerators_calc
            PIN a11(31:0) A11(31:0)
            PIN a12(31:0) A12(31:0)
            PIN a21(31:0) A21(31:0)
            PIN a22(31:0) A22(31:0)
            PIN a31(31:0) A31(31:0)
            PIN a32(31:0) A32(31:0)
            PIN b11(31:0) B11(31:0)
            PIN b21(31:0) B21(31:0)
            PIN b31(31:0) B31(31:0)
            PIN exp2(31:0) XLXN_2(31:0)
            PIN exp3(31:0) XLXN_3(31:0)
            PIN exp1(31:0) XLXN_1(31:0)
            PIN clk CLK
            PIN reset RESET
            PIN START XLXN_41
            PIN num_x(31:0) XLXN_4(31:0)
            PIN num_y(31:0) XLXN_5(31:0)
            PIN rdy XLXN_23
        END BLOCK
        BEGIN BLOCK xy_calc_1 xy_calc
            PIN clk CLK
            PIN div_factor(31:0) XLXN_14(31:0)
            PIN reset RESET
            PIN num_x(31:0) XLXN_4(31:0)
            PIN num_y(31:0) XLXN_5(31:0)
            PIN start XLXN_43
            PIN x(31:0) x(31:0)
            PIN y(31:0) y(31:0)
            PIN rdy XLXN_50
        END BLOCK
        BEGIN BLOCK control MULTILATERATION_CONTROL
            PIN CLK CLK
            PIN div_factor_rdy XLXN_24
            PIN exps_rdy XLXN_22
            PIN nums_rdy XLXN_23
            PIN sclr RESET
            PIN start start
            PIN xy_rdy XLXN_50
            PIN div_factor_start XLXN_42
            PIN exps_start XLXN_58
            PIN nums_start XLXN_41
            PIN rdy rdy
            PIN xy_start XLXN_43
        END BLOCK
    END NETLIST
    BEGIN SHEET 1 3520 2720
        BEGIN BRANCH B31(31:0)
            WIRE 2208 1392 2240 1392
        END BRANCH
        BEGIN BRANCH B21(31:0)
            WIRE 2208 1328 2240 1328
        END BRANCH
        BEGIN BRANCH B11(31:0)
            WIRE 2208 1264 2240 1264
        END BRANCH
        BEGIN BRANCH XLXN_1(31:0)
            WIRE 1072 128 1664 128
            WIRE 1664 128 1664 144
            WIRE 1664 144 2192 144
            WIRE 1664 144 1664 1584
            WIRE 1664 1584 2240 1584
        END BRANCH
        IOMARKER 320 128 A11(31:0) R180 28
        IOMARKER 2208 1392 B31(31:0) R180 28
        IOMARKER 2208 1328 B21(31:0) R180 28
        IOMARKER 2208 1264 B11(31:0) R180 28
        BEGIN BRANCH XLXN_4(31:0)
            WIRE 2624 880 2720 880
            WIRE 2720 880 2720 1264
            WIRE 2720 1264 2992 1264
        END BRANCH
        BEGIN BRANCH XLXN_5(31:0)
            WIRE 2624 1328 2992 1328
        END BRANCH
        BEGIN BRANCH XLXN_14(31:0)
            WIRE 2656 144 2912 144
            WIRE 2912 144 2912 1136
            WIRE 2912 1136 2992 1136
        END BRANCH
        BEGIN BRANCH x(31:0)
            WIRE 3376 1072 3408 1072
        END BRANCH
        BEGIN BRANCH y(31:0)
            WIRE 3376 1232 3408 1232
        END BRANCH
        BEGIN INSTANCE xy_calc_1 2992 1424 R0
        END INSTANCE
        IOMARKER 3408 1072 x(31:0) R0 28
        IOMARKER 3408 1232 y(31:0) R0 28
        IOMARKER 144 1952 CLK R180 28
        IOMARKER 176 2000 RESET R180 28
        BEGIN INSTANCE control 1408 2656 R0
        END INSTANCE
        BEGIN BRANCH XLXN_24
            WIRE 1216 784 1216 2304
            WIRE 1216 2304 1408 2304
            WIRE 1216 784 2672 784
            WIRE 2656 464 2672 464
            WIRE 2672 464 2672 784
        END BRANCH
        BEGIN BRANCH XLXN_22
            WIRE 1072 608 1120 608
            WIRE 1120 608 1120 2368
            WIRE 1120 2368 1408 2368
        END BRANCH
        BEGIN BRANCH XLXN_41
            WIRE 1872 2432 2176 2432
            WIRE 2176 1776 2176 2432
            WIRE 2176 1776 2240 1776
        END BRANCH
        BEGIN BRANCH XLXN_42
            WIRE 1872 2240 2032 2240
            WIRE 2032 464 2032 2240
            WIRE 2032 464 2192 464
        END BRANCH
        BEGIN BRANCH XLXN_43
            WIRE 1872 2624 2864 2624
            WIRE 2864 1392 2864 2624
            WIRE 2864 1392 2992 1392
        END BRANCH
        BEGIN BRANCH XLXN_23
            WIRE 1168 2432 1168 2704
            WIRE 1168 2704 2736 2704
            WIRE 1168 2432 1408 2432
            WIRE 2624 1776 2736 1776
            WIRE 2736 1776 2736 2704
        END BRANCH
        BEGIN BRANCH XLXN_50
            WIRE 1200 2624 1408 2624
            WIRE 1200 2624 1200 2672
            WIRE 1200 2672 3440 2672
            WIRE 3376 1392 3440 1392
            WIRE 3440 1392 3440 2672
        END BRANCH
        BEGIN BRANCH rdy
            WIRE 1872 2528 2016 2528
        END BRANCH
        IOMARKER 2016 2528 rdy R0 28
        BEGIN BRANCH start
            WIRE 1344 2560 1408 2560
        END BRANCH
        IOMARKER 1344 2560 start R180 28
        BEGIN BRANCH RESET
            WIRE 176 2000 288 2000
            WIRE 288 2000 1904 2000
            WIRE 1904 2000 2832 2000
            WIRE 288 2000 288 2496
            WIRE 288 2496 1408 2496
            WIRE 288 512 688 512
            WIRE 288 512 288 2000
            WIRE 1904 400 2192 400
            WIRE 1904 400 1904 1712
            WIRE 1904 1712 2240 1712
            WIRE 1904 1712 1904 2000
            WIRE 2832 1200 2992 1200
            WIRE 2832 1200 2832 2000
        END BRANCH
        BEGIN BRANCH CLK
            WIRE 144 1952 336 1952
            WIRE 336 1952 1872 1952
            WIRE 1872 1952 2784 1952
            WIRE 336 1952 336 2240
            WIRE 336 2240 1408 2240
            WIRE 336 576 688 576
            WIRE 336 576 336 1952
            WIRE 1872 336 2192 336
            WIRE 1872 336 1872 1648
            WIRE 1872 1648 2240 1648
            WIRE 1872 1648 1872 1952
            WIRE 2784 1072 2992 1072
            WIRE 2784 1072 2784 1952
        END BRANCH
        BEGIN BRANCH A12(31:0)
            WIRE 320 192 544 192
            WIRE 544 192 544 944
            WIRE 544 944 2240 944
            WIRE 544 192 688 192
        END BRANCH
        IOMARKER 320 192 A12(31:0) R180 28
        IOMARKER 320 256 A21(31:0) R180 28
        BEGIN BRANCH A21(31:0)
            WIRE 320 256 512 256
            WIRE 512 256 688 256
            WIRE 512 256 512 1008
            WIRE 512 1008 2240 1008
        END BRANCH
        IOMARKER 320 320 A22(31:0) R180 28
        BEGIN BRANCH A22(31:0)
            WIRE 320 320 480 320
            WIRE 480 320 688 320
            WIRE 480 320 480 1072
            WIRE 480 1072 2240 1072
        END BRANCH
        IOMARKER 304 384 A31(31:0) R180 28
        BEGIN BRANCH A31(31:0)
            WIRE 304 384 448 384
            WIRE 448 384 688 384
            WIRE 448 384 448 1136
            WIRE 448 1136 2240 1136
        END BRANCH
        IOMARKER 336 448 A32(31:0) R180 28
        BEGIN BRANCH A32(31:0)
            WIRE 336 448 416 448
            WIRE 416 448 688 448
            WIRE 416 448 416 1200
            WIRE 416 1200 2240 1200
        END BRANCH
        BEGIN INSTANCE exps_calc_1 688 672 R0
        END INSTANCE
        BEGIN BRANCH XLXN_58
            WIRE 624 640 688 640
            WIRE 624 640 624 2064
            WIRE 624 2064 2064 2064
            WIRE 2064 2064 2064 2336
            WIRE 1872 2336 2064 2336
        END BRANCH
        BEGIN INSTANCE num_calc_1 2240 1808 R0
        END INSTANCE
        BEGIN BRANCH A11(31:0)
            WIRE 320 128 576 128
            WIRE 576 128 576 880
            WIRE 576 880 2240 880
            WIRE 576 128 688 128
        END BRANCH
        BEGIN INSTANCE divfaccalc_1 2192 496 R0
        END INSTANCE
        BEGIN BRANCH XLXN_2(31:0)
            WIRE 1072 448 1520 448
            WIRE 1520 448 1520 1456
            WIRE 1520 1456 2240 1456
            WIRE 1520 208 2192 208
            WIRE 1520 208 1520 448
        END BRANCH
        BEGIN BRANCH XLXN_3(31:0)
            WIRE 1072 288 1824 288
            WIRE 1824 288 1824 1520
            WIRE 1824 1520 2240 1520
            WIRE 1824 272 2192 272
            WIRE 1824 272 1824 288
        END BRANCH
    END SHEET
END SCHEMATIC
