VERSION 6
BEGIN SCHEMATIC
    BEGIN ATTR DeviceFamilyName "virtex4"
        DELETE all:0
        EDITNAME all:0
        EDITTRAIT all:0
    END ATTR
    BEGIN NETLIST
        SIGNAL a11(31:0)
        SIGNAL a12(31:0)
        SIGNAL a21(31:0)
        SIGNAL a22(31:0)
        SIGNAL a31(31:0)
        SIGNAL a32(31:0)
        SIGNAL b11(31:0)
        SIGNAL b21(31:0)
        SIGNAL b31(31:0)
        SIGNAL XLXN_110(31:0)
        SIGNAL XLXN_112(31:0)
        SIGNAL ADD_B(31:0)
        SIGNAL MULT_B(31:0)
        SIGNAL ADD_RESULT(31:0)
        SIGNAL ADD_A(31:0)
        SIGNAL exp2(31:0)
        SIGNAL exp3(31:0)
        SIGNAL exp1(31:0)
        SIGNAL MULT_A(31:0)
        SIGNAL clk
        SIGNAL MULT_RESULT(31:0)
        SIGNAL num_x(31:0)
        SIGNAL num_y(31:0)
        SIGNAL XLXN_169(31:0)
        SIGNAL XLXN_174(31:0)
        SIGNAL reset
        SIGNAL XLXN_181(1:0)
        SIGNAL XLXN_183(1:0)
        SIGNAL XLXN_184(1:0)
        SIGNAL XLXN_185(3:0)
        SIGNAL ADD_RDY
        SIGNAL MULT_RDY
        SIGNAL START
        SIGNAL ADD_ND
        SIGNAL MULT_ND
        SIGNAL XLXN_202
        SIGNAL XLXN_203
        SIGNAL XLXN_204
        SIGNAL XLXN_205
        SIGNAL rdy
        PORT Input a11(31:0)
        PORT Input a12(31:0)
        PORT Input a21(31:0)
        PORT Input a22(31:0)
        PORT Input a31(31:0)
        PORT Input a32(31:0)
        PORT Input b11(31:0)
        PORT Input b21(31:0)
        PORT Input b31(31:0)
        PORT Input exp2(31:0)
        PORT Input exp3(31:0)
        PORT Input exp1(31:0)
        PORT Input clk
        PORT Output num_x(31:0)
        PORT Output num_y(31:0)
        PORT Input reset
        PORT Input START
        PORT Output rdy
        BEGIN BLOCKDEF mux32_3
            TIMESTAMP 2007 6 27 20 5 54
            RECTANGLE N 64 -256 368 0 
            RECTANGLE N 0 -236 64 -212 
            LINE N 64 -224 0 -224 
            RECTANGLE N 0 -172 64 -148 
            LINE N 64 -160 0 -160 
            RECTANGLE N 0 -108 64 -84 
            LINE N 64 -96 0 -96 
            RECTANGLE N 0 -44 64 -20 
            LINE N 64 -32 0 -32 
            RECTANGLE N 368 -236 432 -212 
            LINE N 368 -224 432 -224 
        END BLOCKDEF
        BEGIN BLOCKDEF add_fp
            TIMESTAMP 2007 7 14 3 8 18
            RECTANGLE N 32 32 480 384 
            BEGIN LINE W 0 80 32 80 
            END LINE
            BEGIN LINE W 0 112 32 112 
            END LINE
            LINE N 0 208 32 208 
            LINE N 0 240 32 240 
            LINE N 0 304 32 304 
            LINE N 144 416 144 384 
            BEGIN LINE W 512 80 480 80 
            END LINE
            LINE N 512 240 480 240 
        END BLOCKDEF
        BEGIN BLOCKDEF mult_fp
            TIMESTAMP 2007 7 14 3 23 9
            RECTANGLE N 32 32 480 384 
            BEGIN LINE W 0 80 32 80 
            END LINE
            BEGIN LINE W 0 112 32 112 
            END LINE
            LINE N 0 208 32 208 
            LINE N 0 240 32 240 
            LINE N 0 304 32 304 
            LINE N 144 416 144 384 
            BEGIN LINE W 512 80 480 80 
            END LINE
            LINE N 512 240 480 240 
        END BLOCKDEF
        BEGIN BLOCKDEF reg32
            TIMESTAMP 2007 6 27 20 6 4
            RECTANGLE N 64 -256 368 0 
            LINE N 64 -224 0 -224 
            LINE N 64 -160 0 -160 
            LINE N 64 -96 0 -96 
            RECTANGLE N 0 -44 64 -20 
            LINE N 64 -32 0 -32 
            RECTANGLE N 368 -236 432 -212 
            LINE N 368 -224 432 -224 
        END BLOCKDEF
        BEGIN BLOCKDEF mux32_4
            TIMESTAMP 2007 6 27 20 5 58
            RECTANGLE N 64 -320 368 0 
            RECTANGLE N 0 -300 64 -276 
            LINE N 64 -288 0 -288 
            RECTANGLE N 0 -236 64 -212 
            LINE N 64 -224 0 -224 
            RECTANGLE N 0 -172 64 -148 
            LINE N 64 -160 0 -160 
            RECTANGLE N 0 -108 64 -84 
            LINE N 64 -96 0 -96 
            RECTANGLE N 0 -44 64 -20 
            LINE N 64 -32 0 -32 
            RECTANGLE N 368 -300 432 -276 
            LINE N 368 -288 432 -288 
        END BLOCKDEF
        BEGIN BLOCKDEF NUMERATORS_CALC_CONTROL
            TIMESTAMP 2007 6 29 1 26 48
            RECTANGLE N 64 -704 384 0 
            LINE N 64 -672 0 -672 
            LINE N 64 -512 0 -512 
            LINE N 64 -352 0 -352 
            LINE N 64 -192 0 -192 
            LINE N 64 -32 0 -32 
            LINE N 384 -672 448 -672 
            LINE N 384 -608 448 -608 
            LINE N 384 -544 448 -544 
            LINE N 384 -480 448 -480 
            LINE N 384 -416 448 -416 
            LINE N 384 -352 448 -352 
            LINE N 384 -288 448 -288 
            RECTANGLE N 384 -236 448 -212 
            LINE N 384 -224 448 -224 
            RECTANGLE N 384 -172 448 -148 
            LINE N 384 -160 448 -160 
            RECTANGLE N 384 -108 448 -84 
            LINE N 384 -96 448 -96 
            RECTANGLE N 384 -44 448 -20 
            LINE N 384 -32 448 -32 
        END BLOCKDEF
        BEGIN BLOCKDEF mux32_9
            TIMESTAMP 2007 6 27 20 6 0
            RECTANGLE N 64 -640 368 0 
            RECTANGLE N 0 -620 64 -596 
            LINE N 64 -608 0 -608 
            RECTANGLE N 0 -556 64 -532 
            LINE N 64 -544 0 -544 
            RECTANGLE N 0 -492 64 -468 
            LINE N 64 -480 0 -480 
            RECTANGLE N 0 -428 64 -404 
            LINE N 64 -416 0 -416 
            RECTANGLE N 0 -364 64 -340 
            LINE N 64 -352 0 -352 
            RECTANGLE N 0 -300 64 -276 
            LINE N 64 -288 0 -288 
            RECTANGLE N 0 -236 64 -212 
            LINE N 64 -224 0 -224 
            RECTANGLE N 0 -172 64 -148 
            LINE N 64 -160 0 -160 
            RECTANGLE N 0 -108 64 -84 
            LINE N 64 -96 0 -96 
            RECTANGLE N 0 -44 64 -20 
            LINE N 64 -32 0 -32 
            RECTANGLE N 368 -620 432 -596 
            LINE N 368 -608 432 -608 
        END BLOCKDEF
        BEGIN BLOCK add1 add_fp
            PIN a(31:0) ADD_A(31:0)
            PIN b(31:0) ADD_B(31:0)
            PIN operation_nd ADD_ND
            PIN operation_rfd
            PIN sclr reset
            PIN clk clk
            PIN result(31:0) ADD_RESULT(31:0)
            PIN rdy ADD_RDY
        END BLOCK
        BEGIN BLOCK add_a_mux mux32_3
            PIN a(31:0) XLXN_174(31:0)
            PIN b(31:0) XLXN_110(31:0)
            PIN c(31:0) XLXN_112(31:0)
            PIN selector(1:0) XLXN_184(1:0)
            PIN selected(31:0) ADD_A(31:0)
        END BLOCK
        BEGIN BLOCK add_x_tmp reg32
            PIN LOAD XLXN_204
            PIN RESET reset
            PIN CLK clk
            PIN INPUT(31:0) XLXN_174(31:0)
            PIN OUTPUT(31:0) XLXN_110(31:0)
        END BLOCK
        BEGIN BLOCK add_y_tmp reg32
            PIN LOAD XLXN_205
            PIN RESET reset
            PIN CLK clk
            PIN INPUT(31:0) XLXN_174(31:0)
            PIN OUTPUT(31:0) XLXN_112(31:0)
        END BLOCK
        BEGIN BLOCK add_res_reg reg32
            PIN LOAD ADD_RDY
            PIN RESET reset
            PIN CLK clk
            PIN INPUT(31:0) ADD_RESULT(31:0)
            PIN OUTPUT(31:0) XLXN_169(31:0)
        END BLOCK
        BEGIN BLOCK mult_a_mux mux32_4
            PIN a(31:0) exp1(31:0)
            PIN b(31:0) exp2(31:0)
            PIN c(31:0) exp3(31:0)
            PIN d(31:0) XLXN_169(31:0)
            PIN selector(1:0) XLXN_181(1:0)
            PIN selected(31:0) MULT_A(31:0)
        END BLOCK
        BEGIN BLOCK mult_res_reg reg32
            PIN LOAD MULT_RDY
            PIN RESET reset
            PIN CLK clk
            PIN INPUT(31:0) MULT_RESULT(31:0)
            PIN OUTPUT(31:0) XLXN_174(31:0)
        END BLOCK
        BEGIN BLOCK num_x_reg reg32
            PIN LOAD XLXN_202
            PIN RESET reset
            PIN CLK clk
            PIN INPUT(31:0) XLXN_169(31:0)
            PIN OUTPUT(31:0) num_x(31:0)
        END BLOCK
        BEGIN BLOCK num_y_reg reg32
            PIN LOAD XLXN_203
            PIN RESET reset
            PIN CLK clk
            PIN INPUT(31:0) XLXN_169(31:0)
            PIN OUTPUT(31:0) num_y(31:0)
        END BLOCK
        BEGIN BLOCK add_b_mux mux32_3
            PIN a(31:0) MULT_RESULT(31:0)
            PIN b(31:0) XLXN_169(31:0)
            PIN c(31:0) XLXN_174(31:0)
            PIN selector(1:0) XLXN_183(1:0)
            PIN selected(31:0) ADD_B(31:0)
        END BLOCK
        BEGIN BLOCK mult_b_mux mux32_9
            PIN in0(31:0) a11(31:0)
            PIN in1(31:0) a12(31:0)
            PIN in2(31:0) a21(31:0)
            PIN in3(31:0) a22(31:0)
            PIN in4(31:0) a31(31:0)
            PIN in5(31:0) a32(31:0)
            PIN in6(31:0) b11(31:0)
            PIN in7(31:0) b21(31:0)
            PIN in8(31:0) b31(31:0)
            PIN selector(3:0) XLXN_185(3:0)
            PIN selected(31:0) MULT_B(31:0)
        END BLOCK
        BEGIN BLOCK control NUMERATORS_CALC_CONTROL
            PIN CLK clk
            PIN add_rdy ADD_RDY
            PIN mult_rdy MULT_RDY
            PIN SCLR reset
            PIN start START
            PIN add_nd ADD_ND
            PIN add_x_tmp_load XLXN_204
            PIN add_y_tmp_load XLXN_205
            PIN mult_nd MULT_ND
            PIN num_x_load XLXN_202
            PIN num_y_load XLXN_203
            PIN rdy rdy
            PIN add_a_mux_sel(1:0) XLXN_184(1:0)
            PIN add_b_mux_sel(1:0) XLXN_183(1:0)
            PIN mult_a_mux_sl(1:0) XLXN_181(1:0)
            PIN mult_b_mux_sel(3:0) XLXN_185(3:0)
        END BLOCK
        BEGIN BLOCK mult1 mult_fp
            PIN a(31:0) MULT_A(31:0)
            PIN b(31:0) MULT_B(31:0)
            PIN operation_nd MULT_ND
            PIN operation_rfd
            PIN sclr reset
            PIN clk clk
            PIN result(31:0) MULT_RESULT(31:0)
            PIN rdy MULT_RDY
        END BLOCK
    END NETLIST
    BEGIN SHEET 1 3520 2720
        BEGIN BRANCH a11(31:0)
            WIRE 224 656 400 656
        END BRANCH
        BEGIN BRANCH a12(31:0)
            WIRE 224 720 400 720
        END BRANCH
        BEGIN BRANCH a21(31:0)
            WIRE 224 784 400 784
        END BRANCH
        BEGIN BRANCH a22(31:0)
            WIRE 224 848 400 848
        END BRANCH
        BEGIN BRANCH a31(31:0)
            WIRE 224 912 400 912
        END BRANCH
        BEGIN BRANCH a32(31:0)
            WIRE 224 976 400 976
        END BRANCH
        BEGIN BRANCH b11(31:0)
            WIRE 224 1040 400 1040
        END BRANCH
        BEGIN BRANCH b21(31:0)
            WIRE 224 1104 400 1104
        END BRANCH
        BEGIN BRANCH b31(31:0)
            WIRE 224 1168 400 1168
        END BRANCH
        IOMARKER 224 656 a11(31:0) R180 28
        IOMARKER 224 720 a12(31:0) R180 28
        IOMARKER 224 784 a21(31:0) R180 28
        IOMARKER 224 848 a22(31:0) R180 28
        IOMARKER 224 912 a31(31:0) R180 28
        IOMARKER 224 976 a32(31:0) R180 28
        IOMARKER 224 1040 b11(31:0) R180 28
        IOMARKER 224 1104 b21(31:0) R180 28
        IOMARKER 224 1168 b31(31:0) R180 28
        BEGIN INSTANCE add_y_tmp 2368 832 R0
        END INSTANCE
        BEGIN INSTANCE add_x_tmp 2368 512 R0
        END INSTANCE
        BEGIN BRANCH XLXN_110(31:0)
            WIRE 2800 288 2944 288
        END BRANCH
        BEGIN BRANCH XLXN_112(31:0)
            WIRE 2800 608 2816 608
            WIRE 2816 352 2944 352
            WIRE 2816 352 2816 608
        END BRANCH
        BEGIN INSTANCE add1 1968 1488 R0
        END INSTANCE
        BEGIN BRANCH exp2(31:0)
            WIRE 224 192 384 192
        END BRANCH
        BEGIN BRANCH exp3(31:0)
            WIRE 224 256 384 256
        END BRANCH
        BEGIN BRANCH exp1(31:0)
            WIRE 224 128 384 128
        END BRANCH
        BEGIN INSTANCE mult_a_mux 384 416 R0
        END INSTANCE
        IOMARKER 224 192 exp2(31:0) R180 28
        IOMARKER 224 256 exp3(31:0) R180 28
        IOMARKER 224 128 exp1(31:0) R180 28
        IOMARKER 864 1152 clk R180 28
        BEGIN INSTANCE mult_res_reg 1776 656 R0
        END INSTANCE
        BEGIN BRANCH num_x(31:0)
            WIRE 3312 1904 3328 1904
        END BRANCH
        BEGIN BRANCH num_y(31:0)
            WIRE 3312 2208 3328 2208
        END BRANCH
        BEGIN INSTANCE num_x_reg 2880 2128 R0
        END INSTANCE
        BEGIN INSTANCE num_y_reg 2880 2432 R0
        END INSTANCE
        IOMARKER 3328 1904 num_x(31:0) R0 28
        IOMARKER 3328 2208 num_y(31:0) R0 28
        BEGIN INSTANCE add_a_mux 2944 448 R0
        END INSTANCE
        BEGIN BRANCH XLXN_169(31:0)
            WIRE 32 16 3504 16
            WIRE 3504 16 3504 1376
            WIRE 3504 1376 3504 1792
            WIRE 32 16 32 320
            WIRE 32 320 384 320
            WIRE 1200 1616 1280 1616
            WIRE 1200 1616 1200 2016
            WIRE 1200 2016 2752 2016
            WIRE 2752 2016 2752 2096
            WIRE 2752 2096 2880 2096
            WIRE 2752 2096 2752 2400
            WIRE 2752 2400 2880 2400
            WIRE 2752 1792 3504 1792
            WIRE 2752 1792 2752 2016
            WIRE 3328 1376 3504 1376
        END BRANCH
        BEGIN BRANCH XLXN_174(31:0)
            WIRE 1168 1440 1168 1680
            WIRE 1168 1680 1280 1680
            WIRE 1168 1440 1616 1440
            WIRE 1616 800 1616 1440
            WIRE 1616 800 2240 800
            WIRE 2240 800 2368 800
            WIRE 2208 432 2240 432
            WIRE 2240 432 2240 480
            WIRE 2240 480 2368 480
            WIRE 2240 480 2240 800
            WIRE 2240 224 2944 224
            WIRE 2240 224 2240 432
        END BRANCH
        BEGIN INSTANCE add_res_reg 2896 1600 R0
        END INSTANCE
        BEGIN INSTANCE add_b_mux 1280 1776 R0
        END INSTANCE
        BEGIN INSTANCE mult_b_mux 400 1264 R0
        END INSTANCE
        IOMARKER 112 2336 reset R180 28
        BEGIN BRANCH XLXN_181(1:0)
            WIRE 368 32 368 384
            WIRE 368 384 384 384
            WIRE 368 32 928 32
            WIRE 928 32 928 2128
            WIRE 656 2128 928 2128
        END BRANCH
        BEGIN BRANCH XLXN_183(1:0)
            WIRE 656 2064 1264 2064
            WIRE 1264 1744 1280 1744
            WIRE 1264 1744 1264 2064
        END BRANCH
        BEGIN BRANCH XLXN_184(1:0)
            WIRE 656 2000 736 2000
            WIRE 736 1280 2928 1280
            WIRE 736 1280 736 2000
            WIRE 2928 416 2944 416
            WIRE 2928 416 2928 1280
        END BRANCH
        BEGIN BRANCH XLXN_185(3:0)
            WIRE 384 1232 400 1232
            WIRE 384 1232 384 1328
            WIRE 384 1328 720 1328
            WIRE 720 1328 720 2192
            WIRE 656 2192 720 2192
        END BRANCH
        IOMARKER 112 2192 START R180 28
        BEGIN BRANCH XLXN_202
            WIRE 656 1808 688 1808
            WIRE 688 1808 688 1968
            WIRE 688 1968 2544 1968
            WIRE 2544 1904 2544 1968
            WIRE 2544 1904 2880 1904
        END BRANCH
        BEGIN BRANCH XLXN_203
            WIRE 656 1872 1760 1872
            WIRE 1760 1872 1760 2208
            WIRE 1760 2208 2880 2208
        END BRANCH
        BEGIN BRANCH XLXN_204
            WIRE 656 1616 1024 1616
            WIRE 1024 288 1024 1616
            WIRE 1024 288 2368 288
        END BRANCH
        BEGIN BRANCH XLXN_205
            WIRE 656 1680 688 1680
            WIRE 688 1472 2272 1472
            WIRE 688 1472 688 1680
            WIRE 2272 608 2272 1472
            WIRE 2272 608 2368 608
        END BRANCH
        BEGIN BRANCH rdy
            WIRE 656 1936 768 1936
        END BRANCH
        IOMARKER 768 1936 rdy R0 28
        BEGIN INSTANCE mult1 1088 544 R0
        END INSTANCE
        BEGIN BRANCH START
            WIRE 112 2192 208 2192
        END BRANCH
        BEGIN BRANCH reset
            WIRE 112 2336 144 2336
            WIRE 144 2336 144 2368
            WIRE 144 2368 944 2368
            WIRE 944 2368 944 2432
            WIRE 944 2432 2816 2432
            WIRE 144 2032 144 2336
            WIRE 144 2032 208 2032
            WIRE 944 848 1088 848
            WIRE 944 848 944 1008
            WIRE 944 1008 944 1792
            WIRE 944 1792 1968 1792
            WIRE 944 1792 944 2368
            WIRE 944 1008 1776 1008
            WIRE 1776 1008 2352 1008
            WIRE 1728 496 1776 496
            WIRE 1728 496 1728 720
            WIRE 1728 720 1776 720
            WIRE 1776 720 1776 1008
            WIRE 2352 352 2368 352
            WIRE 2352 352 2352 672
            WIRE 2352 672 2352 1008
            WIRE 2352 672 2368 672
            WIRE 2816 1440 2896 1440
            WIRE 2816 1440 2816 1968
            WIRE 2816 1968 2880 1968
            WIRE 2816 1968 2816 2272
            WIRE 2816 2272 2880 2272
            WIRE 2816 2272 2816 2432
        END BRANCH
        BEGIN BRANCH clk
            WIRE 144 1296 912 1296
            WIRE 912 1296 912 2464
            WIRE 912 2464 2112 2464
            WIRE 2112 2464 2848 2464
            WIRE 144 1296 144 1552
            WIRE 144 1552 208 1552
            WIRE 864 1152 912 1152
            WIRE 912 1152 1232 1152
            WIRE 1232 1152 1712 1152
            WIRE 1712 1152 2320 1152
            WIRE 912 1152 912 1296
            WIRE 1232 960 1232 1152
            WIRE 1712 560 1776 560
            WIRE 1712 560 1712 1152
            WIRE 2112 1904 2112 2464
            WIRE 2320 416 2368 416
            WIRE 2320 416 2320 736
            WIRE 2320 736 2368 736
            WIRE 2320 736 2320 1152
            WIRE 2848 1504 2896 1504
            WIRE 2848 1504 2848 2032
            WIRE 2848 2032 2880 2032
            WIRE 2848 2032 2848 2336
            WIRE 2848 2336 2880 2336
            WIRE 2848 2336 2848 2464
        END BRANCH
        BEGIN INSTANCE control 208 2224 R0
        END INSTANCE
        BEGIN BRANCH MULT_A(31:0)
            WIRE 816 128 944 128
            WIRE 944 128 944 624
            WIRE 944 624 1088 624
        END BRANCH
        BEGIN BRANCH MULT_B(31:0)
            WIRE 832 656 1088 656
        END BRANCH
        BEGIN BRANCH MULT_RDY
            WIRE 192 1872 208 1872
            WIRE 192 1872 192 2384
            WIRE 192 2384 1808 2384
            WIRE 1600 784 1632 784
            WIRE 1632 432 1776 432
            WIRE 1632 432 1632 704
            WIRE 1632 704 1632 784
            WIRE 1632 704 1808 704
            WIRE 1808 704 1808 2384
        END BRANCH
        BEGIN BRANCH MULT_RESULT(31:0)
            WIRE 1216 1456 1216 1552
            WIRE 1216 1552 1280 1552
            WIRE 1216 1456 1664 1456
            WIRE 1600 624 1664 624
            WIRE 1664 624 1776 624
            WIRE 1664 624 1664 1456
        END BRANCH
        BEGIN BRANCH MULT_ND
            WIRE 656 1744 880 1744
            WIRE 880 752 1088 752
            WIRE 880 752 880 1744
        END BRANCH
        BEGIN BRANCH ADD_A(31:0)
            WIRE 1952 1296 3440 1296
            WIRE 1952 1296 1952 1568
            WIRE 1952 1568 1968 1568
            WIRE 3376 224 3440 224
            WIRE 3440 224 3440 1296
        END BRANCH
        BEGIN BRANCH ADD_B(31:0)
            WIRE 1712 1552 1824 1552
            WIRE 1824 1552 1824 1600
            WIRE 1824 1600 1968 1600
        END BRANCH
        BEGIN BRANCH ADD_ND
            WIRE 656 1552 704 1552
            WIRE 704 1552 704 1856
            WIRE 704 1856 1776 1856
            WIRE 1776 1696 1776 1856
            WIRE 1776 1696 1968 1696
        END BRANCH
        BEGIN BRANCH ADD_RDY
            WIRE 160 1712 208 1712
            WIRE 160 1712 160 2400
            WIRE 160 2400 2592 2400
            WIRE 2480 1728 2592 1728
            WIRE 2592 1728 2688 1728
            WIRE 2592 1728 2592 2400
            WIRE 2688 1376 2896 1376
            WIRE 2688 1376 2688 1728
        END BRANCH
        BEGIN BRANCH ADD_RESULT(31:0)
            WIRE 2480 1568 2576 1568
            WIRE 2576 1568 2896 1568
        END BRANCH
    END SHEET
END SCHEMATIC
